package hk.advanpro.cloud.android.callback;

import hk.advanpro.cloud.api.callback.ResponseFailureCallback;
import hk.advanpro.cloud.api.callback.ResponseSuccessCallback;
import hk.advanpro.cloud.api.result.ResponseResult;

public abstract class CloudResponseCallback<T extends ResponseResult> implements ResponseFailureCallback<T>, ResponseSuccessCallback<T> {

    public abstract void onSuccess(T res);

    public abstract void onError(int code, String message);

    @Override
    public void call(T res) {
        onSuccess(res);
    }

    @Override
    public void call(Throwable throwable, T res) {
        if (throwable != null) {
            onError(0, throwable.getMessage());
        } else if (res != null) {
            onError(res.getCode(), res.getMsg());
        } else {
            onError(0, "result is null");
        }
    }

}