package hk.advanpro.cloud.android.callback;

import hk.advanpro.cloud.android.common.AndroidUtils;
import hk.advanpro.cloud.api.result.ResponseResult;

public abstract class UIThreadCloudResponseCallback<T extends ResponseResult> extends CloudResponseCallback<T> {

    public void onSuccess(final T res) {
        AndroidUtils.runOnUIThread(new Runnable() {
            @Override
            public void run() {
                successOnUIThread(res);
            }
        });
    }


    public void onError(final int code, final String message) {
        AndroidUtils.runOnUIThread(new Runnable() {
            @Override
            public void run() {
                errorOnUIThread(code, message);
            }
        });
    }

    public abstract void successOnUIThread(T res);


    public abstract void errorOnUIThread(int code, String message);

}