package hk.advanpro.cloud.android.callback;

import hk.advanpro.cloud.android.common.AndroidUtils;
import hk.advanpro.cloud.api.callback.ResponseErrorCallback;
import okhttp3.Response;

/**
 * 请求错误响应回调接口。
 * Created by jalin on 2017/11/21.
 */

public abstract class UIThreadResponseErrorCallback implements ResponseErrorCallback {

    public abstract void callOnUiThread(Response response, Throwable throwable);

    @Override
    final public void call(final Response response, final Throwable throwable) {
        AndroidUtils.runOnUIThread(new Runnable() {
            @Override
            public void run() {
                callOnUiThread(response, throwable);
            }
        });
    }
}
