package hk.advanpro.cloud.android.callback;

import hk.advanpro.cloud.android.common.AndroidUtils;
import hk.advanpro.cloud.api.callback.ResponseFailureCallback;
import hk.advanpro.cloud.api.result.ResponseResult;
import okhttp3.Response;

/**
 * 请求错误响应回调接口。
 * Created by jalin on 2017/11/21.
 */

public abstract class UIThreadResponseFailureCallback<T extends ResponseResult> implements ResponseFailureCallback<T> {

    public abstract void callOnUiThread(Throwable throwable, T res);

    @Override
    public void call(final Throwable throwable, final T res) {
        AndroidUtils.runOnUIThread(new Runnable() {
            @Override
            public void run() {
                callOnUiThread(throwable, res);
            }
        });
    }
}
