package hk.advanpro.cloud.android.callback;

import hk.advanpro.cloud.android.common.AndroidUtils;
import hk.advanpro.cloud.api.callback.ResponseSuccessCallback;
import hk.advanpro.cloud.api.result.ResponseResult;
import okhttp3.Response;

/**
 * 请求成功响应回调接口。
 * Created by jalin on 2017/11/21.
 */

public abstract class UIThreadResponseSuccessCallback<T extends ResponseResult> implements ResponseSuccessCallback<T> {
    public abstract void callOnUiThread(T res);

    @Override
    final public void call(final ResponseResult res) {
        AndroidUtils.runOnUIThread(new Runnable() {
            @Override
            public void run() {
                callOnUiThread((T) res);
            }
        });
    }
}
