package hk.advanpro.cloud.android.common;

import android.os.Build;
import android.os.Handler;
import android.os.Looper;
import android.os.Message;

import java.util.UUID;

/**
 * Created by jalin on 2017/11/16.
 */

public class AndroidUtils {
    public static Handler uiHandler = new Handler(Looper.getMainLooper()) {
        @Override
        public void handleMessage(Message msg) {
            super.handleMessage(msg);
        }
    };

    public static void runOnUIThread(Runnable runnable) {
        uiHandler.post(runnable);
    }

    /**
     * 获得独一无二的Psuedo ID
     *
     * @return Psuedo ID
     */
    public static String getUniquePsuedoID() {
        try {
            //API>=9 使用serial号
            return Build.class.getField("SERIAL").get(null).toString();
        } catch (Exception e) {
            //serial需要一个初始化
            e.printStackTrace();
        }

        //使用硬件信息拼凑出来的15位号码
        String serial = "serial"; // 随便一个初始化
        String devIDShort = "35" +
                Build.BOARD.length() % 10 + Build.BRAND.length() % 10 +
                Build.CPU_ABI.length() % 10 + Build.DEVICE.length() % 10 +
                Build.DISPLAY.length() % 10 + Build.HOST.length() % 10 +
                Build.ID.length() % 10 + Build.MANUFACTURER.length() % 10 +
                Build.MODEL.length() % 10 + Build.PRODUCT.length() % 10 +
                Build.TAGS.length() % 10 + Build.TYPE.length() % 10 +
                Build.USER.length() % 10; //13 位
        return new UUID(devIDShort.hashCode(), serial.hashCode()).toString();
    }
}
