package hk.advanpro.cloud.android.common;

import com.alibaba.fastjson.JSON;
import com.nimbusds.jwt.SignedJWT;

import java.text.ParseException;

/**
 * token解析工具类
 * Created by jalin on 2017/10/30.
 */

public class TokenUtil {

    /**
     * 解析安润普云平台的Token
     *
     * @param token
     * @return AdvanproToken 安润普云平台的Token对象
     * @throws ParseException
     */
    public static AdvanproToken parseAdvanproToken(String token) throws ParseException {
        String jsonValue = parseToken(token);
        return JSON.parseObject(jsonValue, AdvanproToken.class);
    }

    /**
     * 解析token
     *
     * @param token
     * @return 字符串
     * @throws ParseException
     */
    public static String parseToken(String token) throws ParseException {
        SignedJWT signedJWT = SignedJWT.parse(token);
        String jsonValue = signedJWT.getPayload().toString();
        return jsonValue;
    }

}
