package hk.advanpro.cloud.android.model;

import android.content.Context;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.os.Build;

import hk.advanpro.cloud.android.common.AndroidUtils;

/**
 * Created by jalin on 2017/11/17.
 */

public class AndroidUserAgent implements UserAgent {
    private String userAgent;
    private Context context;

    public AndroidUserAgent(Context context) {
        this.context = context;
    }

    @Override
    final public String getUserAgent() {
        if (userAgent == null) {
            userAgent = "";
            String brand = Build.BRAND == null ? "" : Build.BRAND;
            String model = Build.MODEL == null ? "" : Build.MODEL;
            userAgent += getAppName() + "/" + getAppVersionName();
            userAgent += " (" + brand + model + ") ";
            userAgent += "android/" + Build.VERSION.RELEASE;
            userAgent += " (" + AndroidUtils.getUniquePsuedoID() + ")";
        }
        return userAgent;
    }

    public void setUserAgent(String userAgent) {
        this.userAgent = userAgent;
    }

    public String getAppName() {
        return context.getPackageName();
    }

    public String getAppVersionName() {
        try {
            //获取packagemanager的实例
            PackageManager packageManager = context.getPackageManager();
            //getPackageName()是你当前类的包名，0代表是获取版本信息
            PackageInfo packInfo = packageManager.getPackageInfo(context.getPackageName(), 0);
            return packInfo.versionName;
        } catch (Exception e) {
            return "";
        }
    }

}
