package hk.advanpro.cloud.api.annotation;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

import hk.advanpro.cloud.api.callback.ResponseErrorCallback;
import hk.advanpro.cloud.api.callback.ResponseFailureCallback;
import hk.advanpro.cloud.api.interceptor.ResponseInterceptor;

/**
 * 请求拦截标记
 * Created by yejianfei on 2017/8/15.
 */
@Target({ElementType.PARAMETER})
@Retention(RetentionPolicy.RUNTIME)
public @interface Response {

    Class<? extends ResponseFailureCallback> failure() default ResponseFailureCallback.class;

    Class<? extends ResponseErrorCallback> error() default ResponseErrorCallback.class;

    Class<? extends ResponseInterceptor> interceptor() default ResponseInterceptor.class;
}
