package hk.advanpro.cloud.api.client;


import hk.advanpro.cloud.api.CloudRequestContext;
import hk.advanpro.cloud.api.callback.ResponseErrorCallback;
import hk.advanpro.cloud.api.callback.ResponseFailureCallback;
import hk.advanpro.cloud.api.interceptor.RequestInterceptor;
import hk.advanpro.cloud.api.interceptor.ResponseInterceptor;
import hk.advanpro.cloud.api.result.ResponseResult;

/**
 * 云端请求接口，该接口只提供GET,POST,PUT,DELETE,FORM等基础的操作。
 * Created by yejianfei on 2017/8/12.
 */

public interface CloudApi {

    void addHeader(String name, String value);

    void addHeader(String name, RequestInterceptor interceptor);

    void addResponseInterceptor(ResponseInterceptor interceptor);

    void addResponseInterceptor(ResponseFailureCallback interceptor);

    void addResponseInterceptor(ResponseErrorCallback interceptor);

    void addResponseInterceptor(ResponseInterceptor interceptor, ResponseFailureCallback failureCallback, ResponseErrorCallback errorCallback);

    <T extends ResponseResult> CloudRequestContext<T> get(String url, Class<T> tClass);

    <T extends ResponseResult> CloudRequestContext<T> post(String url, Class<T> tClass);

    <T extends ResponseResult> CloudRequestContext<T> post(String url, String body, Class<T> tClass);

    <T extends ResponseResult> CloudRequestContext<T> put(String url, Class<T> tClass);

    <T extends ResponseResult> CloudRequestContext<T> put(String url, String body, Class<T> tClass);

    <T extends ResponseResult> CloudRequestContext<T> delete(String url, Class<T> tClass);

    <T extends ResponseResult> CloudRequestContext<T> delete(String url, String body, Class<T> tClass);
}
