package hk.advanpro.cloud.api.result.cms;

import java.io.Serializable;

/**
 * 音乐专辑
 * Created by Mac on 18/8/17.
 */

public class MusicAlbumResult implements Serializable {
    private int sequence;//显示顺序
    private String id;//栏目ID
    private String name;//专辑名称
    private String cover;//封面
    private String desc;//简介
    private Extras extras;// 额外信息

    public static class Extras implements Serializable {
        private int music_count;//曲目数量
        private int audience;//歌曲听众数量

        public int getMusic_count() {
            return music_count;
        }

        public void setMusic_count(int music_count) {
            this.music_count = music_count;
        }

        public int getAudience() {
            return audience;
        }

        public void setAudience(int audience) {
            this.audience = audience;
        }
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getSequence() {
        return sequence;
    }

    public void setSequence(int sequence) {
        this.sequence = sequence;
    }

    public String getCover() {
        return cover;
    }

    public void setCover(String cover) {
        this.cover = cover;
    }

    public String getDesc() {
        return desc;
    }

    public void setDesc(String desc) {
        this.desc = desc;
    }

    public Extras getExtras() {
        return extras;
    }

    public void setExtras(Extras extras) {
        this.extras = extras;
    }

    public int getMusic_count() {
        if (getExtras() != null) {
            return getExtras().getMusic_count();
        }
        return 0;
    }

    public int getAudience() {
        if (getExtras() != null) {
            return getExtras().getAudience();
        }
        return 0;
    }

    /**
     * 增加播放量
     *
     * @param inc
     */
    public void addAudience(int inc) {
        if (getExtras() != null) {
            getExtras().setAudience(getExtras().getAudience() + inc);
        }
    }


}
