package hk.advanpro.cloud.api.result.course;

import com.alibaba.fastjson.JSONObject;

import java.io.Serializable;
import java.util.Date;

import hk.advanpro.cloud.api.result.oc.OrderDetailResult;
import hk.advanpro.cloud.api.result.qc.OrderResult;

/**
 * 培训班报名详情
 */
public class TrainClassEnrollResult {

    private String id;
    private Date signin_time;
    private User user;

    //培训班信息
    private JSONObject training_class;

    //订单信息
    private JSONObject order;

    // 保险
    private Insurance insurance;

    //证书信息
    private Certificate certificate;
    /**
     * 状态
     * - 0:已关闭
     * - 1:待付款
     * - 5:待开课
     * - 10:待评价
     * - 15:已评价
     * - 20:已取消
     * - 25:退款中
     * - 30:已退款
     */
    private int status;
    // 操作人
    private JSONObject operator;

    public static class User {
        private String id;
        private String name;
        private String photo;
        private String sex;

        public String getId() {
            return id;
        }

        public void setId(String id) {
            this.id = id;
        }

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }

        public String getPhoto() {
            return photo;
        }

        public void setPhoto(String photo) {
            this.photo = photo;
        }

        public String getSex() {
            return sex;
        }

        public void setSex(String sex) {
            this.sex = sex;
        }
    }

    public static class Insurance {
        // 价格
        float price;
        // 险种类型
        int type;

        public float getPrice() {
            return price;
        }

        public void setPrice(float price) {
            this.price = price;
        }

        public int getType() {
            return type;
        }

        public void setType(int type) {
            this.type = type;
        }
    }

    public static class Certificate {
        /**
         * 证书类型
         * - 1:电子证书
         * - 2: 实体证书
         */
        int type;
        float price;//价格
        String receiver;//收件人
        String province;//收货人省份
        String city;//收货人城市
        String county;//收货人区/县
        String address;//收获地址
        String phone;//电话号码
        String postcode;//邮政编码

        public int getType() {
            return type;
        }

        public void setType(int type) {
            this.type = type;
        }

        public float getPrice() {
            return price;
        }

        public void setPrice(float price) {
            this.price = price;
        }

        public String getReceiver() {
            return receiver;
        }

        public void setReceiver(String receiver) {
            this.receiver = receiver;
        }

        public String getProvince() {
            return province;
        }

        public void setProvince(String province) {
            this.province = province;
        }

        public String getCity() {
            return city;
        }

        public void setCity(String city) {
            this.city = city;
        }

        public String getCounty() {
            return county;
        }

        public void setCounty(String county) {
            this.county = county;
        }

        public String getAddress() {
            return address;
        }

        public void setAddress(String address) {
            this.address = address;
        }

        public String getPhone() {
            return phone;
        }

        public void setPhone(String phone) {
            this.phone = phone;
        }

        public String getPostcode() {
            return postcode;
        }

        public void setPostcode(String postcode) {
            this.postcode = postcode;
        }
    }

    public User getUser() {
        return user;
    }

    public void setUser(User user) {
        this.user = user;
    }

    /**
     * 获取培训班状态
     *
     * @return
     */
    public int getTrainClassStatus() {
        if (training_class != null & training_class.containsKey("data")) {
            TrainClassResult trainClass = training_class.getObject("data", TrainClassResult.class);
            return trainClass.getStatus();
        }
        return 0;
    }

    /**
     * 获取培训班名字
     *
     * @return
     */
    public String getTrainClassName() {
        if (training_class != null & training_class.containsKey("data")) {
            TrainClassResult trainClass = training_class.getObject("data", TrainClassResult.class);
            return trainClass.getName();
        }
        return "";
    }

    public String getTrainClassCourseName() {
        if (training_class != null & training_class.containsKey("data")) {
            TrainClassResult trainClass = training_class.getObject("data", TrainClassResult.class);
            return trainClass.getCourseName();
        }
        return "";
    }

    public TrainClassResult getTrainClass() {
        if (training_class != null & training_class.containsKey("data")) {
            TrainClassResult trainClass = training_class.getObject("data", TrainClassResult.class);
            return trainClass;
        }
        return null;
    }

    public OrderDetailResult getOrderDetailResult() {
        if (order != null & order.containsKey("data")) {
            OrderDetailResult orderResult = order.getObject("data", OrderDetailResult.class);
            return orderResult;
        }
        return null;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public Date getSignin_time() {
        return signin_time;
    }

    public void setSignin_time(Date signin_time) {
        this.signin_time = signin_time;
    }

    public JSONObject getTraining_class() {
        return training_class;
    }

    public void setTraining_class(JSONObject training_class) {
        this.training_class = training_class;
    }

    public JSONObject getOrder() {
        return order;
    }

    public void setOrder(JSONObject order) {
        this.order = order;
    }

    public int getStatus() {
        return status;
    }

    public void setStatus(int status) {
        this.status = status;
    }

    public JSONObject getOperator() {
        return operator;
    }

    public void setOperator(JSONObject operator) {
        this.operator = operator;
    }

    public Insurance getInsurance() {
        return insurance;
    }

    public void setInsurance(Insurance insurance) {
        this.insurance = insurance;
    }

    public Certificate getCertificate() {
        return certificate;
    }

    public void setCertificate(Certificate certificate) {
        this.certificate = certificate;
    }
}
