package hk.advanpro.cloud.api.result.course;


import com.alibaba.fastjson.JSONObject;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * 训练培训班
 */
public class TrainClassResult implements Serializable {

    String id;//培训班id
    String name;//培训班名
    String desc;//培训班详情
    TrainClassLocation localtion;//培训班位置
    Date open_time;//开课时间
    Date final_time;//终止时间

    // 报名二维码
    String signin_qrcode;

    Coach coach;// 教练信息

    //报名信息
    Enroll enroll;
    /**
     * - 0:禁用
     * - 2:待审核
     * - 3:审核通过/报名中
     * - 4:审核不通过
     * - 5:待开课
     * - 6:已完成
     * - 7:待取消
     * - 8:已取消
     */
    int status;

    JSONObject price;//价格

    JSONObject course;// 课程

    Comment comment;// 评分

    List<String> pictures;//图片
    List<TrainClassEnrollResult> no_class_students;//插班学生

    // 审核不通过原因
    String audit_reason;

    public static class Comment {
        int total_score; //评论总分
        int members_count; //评论总人数

        public int getTotal_score() {
            return total_score;
        }

        public void setTotal_score(int total_score) {
            this.total_score = total_score;
        }

        public int getMembers_count() {
            return members_count;
        }

        public void setMembers_count(int members_count) {
            this.members_count = members_count;
        }
    }

    /**
     * 报名信息
     */
    public static class Enroll {
        int min;//最小报名人数
        int max;//最大报名人数
        int enrolled_num;//已经报名人数
        int sign_in_num;// 签到人数

        public int getMin() {
            return min;
        }

        public void setMin(int min) {
            this.min = min;
        }

        public int getMax() {
            return max;
        }

        public void setMax(int max) {
            this.max = max;
        }

        public int getEnrolled_num() {
            return enrolled_num;
        }

        public void setEnrolled_num(int enrolled_num) {
            this.enrolled_num = enrolled_num;
        }

        public int getSign_in_num() {
            return sign_in_num;
        }

        public void setSign_in_num(int sign_in_num) {
            this.sign_in_num = sign_in_num;
        }
    }

    public static class Coach {
        String id;
        //教练信息
        JSONObject data;

        public String getId() {
            return id;
        }

        public void setId(String id) {
            this.id = id;
        }

        public JSONObject getData() {
            return data;
        }

        public void setData(JSONObject data) {
            this.data = data;
        }
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDesc() {
        return desc;
    }

    public void setDesc(String desc) {
        this.desc = desc;
    }

    public TrainClassLocation getLocaltion() {
        return localtion;
    }

    public void setLocaltion(TrainClassLocation localtion) {
        this.localtion = localtion;
    }

    public Date getOpen_time() {
        return open_time;
    }

    public void setOpen_time(Date open_time) {
        this.open_time = open_time;
    }

    public Date getFinal_time() {
        return final_time;
    }

    public void setFinal_time(Date final_time) {
        this.final_time = final_time;
    }

    public Coach getCoach() {
        return coach;
    }

    public void setCoach(Coach coach) {
        this.coach = coach;
    }

    public Enroll getEnroll() {
        return enroll;
    }

    public void setEnroll(Enroll enroll) {
        this.enroll = enroll;
    }

    public int getStatus() {
        return status;
    }

    public void setStatus(int status) {
        this.status = status;
    }

    public JSONObject getPrice() {
        return price;
    }

    public void setPrice(JSONObject price) {
        this.price = price;
    }

    public String getSignin_qrcode() {
        return signin_qrcode;
    }

    public void setSignin_qrcode(String signin_qrcode) {
        this.signin_qrcode = signin_qrcode;
    }

    public Comment getComment() {
        return comment;
    }

    public void setComment(Comment comment) {
        this.comment = comment;
    }

    public double getPriceDefault() {
        if (price != null && price.containsKey("amount")) {
            return price.getDoubleValue("amount");
        }
        return 0;
    }

    public JSONObject getCourse() {
        return course;
    }

    public void setCourse(JSONObject course) {
        this.course = course;
    }

    public String getCourseName() {
        if (course != null && course.containsKey("data")) {
            JSONObject data = course.getJSONObject("data");
            if (data.containsKey("name")) {
                return data.getString("name");
            }
        }
        return "";
    }

    public String getCourseId() {
        if (course != null && course.containsKey("data")) {
            JSONObject data = course.getJSONObject("data");
            if (data.containsKey("id")) {
                return data.getString("id");
            }
        }
        return "";
    }

    public String getCoachName() {
        if (getCoach().getData() != null && getCoach().getData().containsKey("profiles")) {
            JSONObject profiles = getCoach().getData().getJSONObject("profiles");
            if (profiles != null && profiles.containsKey("info")) {
                JSONObject info = profiles.getJSONObject("info");
                if (info != null && info.containsKey("verified")) {
                    return info.getJSONObject("verified").getString("name");
                }
            }
        }

        if (getCoach().getData() != null && getCoach().getData().containsKey("nick_name")) {
            return getCoach().getData().getString("nick_name");
        }
        return "";
    }

    public int getCoachLevel() {
        if (getCoach().getData() != null && getCoach().getData().containsKey("profiles")) {
            JSONObject profiles = getCoach().getData().getJSONObject("profiles");
            if (profiles != null && profiles.containsKey("info")) {
                JSONObject info = profiles.getJSONObject("info");
                if (info != null && info.containsKey("level")) {
                    return info.getIntValue("level");
                }
            }
        }
        return 4;
    }

    public String getCoachPhoto() {
        if (getCoach().getData() != null && getCoach().getData().containsKey("photo")) {
            return getCoach().getData().getString("photo");
        }
        return "";
    }

    public String getCoachSex() {
        if (getCoach().getData() != null && getCoach().getData().containsKey("sex")) {
            return getCoach().getData().getString("sex");
        }
        return "";
    }

    public List<String> getPictures() {
        return pictures;
    }

    public void setPictures(List<String> pictures) {
        this.pictures = pictures;
    }

    public List<TrainClassEnrollResult> getNo_class_students() {
        return no_class_students;
    }

    public void setNo_class_students(List<TrainClassEnrollResult> no_class_students) {
        this.no_class_students = no_class_students;
    }

    public String getAudit_reason() {
        return audit_reason;
    }

    public void setAudit_reason(String audit_reason) {
        this.audit_reason = audit_reason;
    }
}
