package hk.advanpro.cloud.api.result.ddc;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.annotation.JSONField;

import java.io.Serializable;
import java.util.Date;

/**
 * Created by jalin on 2017/9/28.
 */

public class MyDeviceResult implements Serializable {
    @JSONField(name = "id")
    private long id;

    /**
     * 设备编号（设备ID）
     */
    @JSONField(name = "code")
    private String code;

    /**
     * 设备校验码(VV号)
     */
    @JSONField(name = "vcode")
    private String vcode;

    /**
     * 设备mac地址
     */
    @JSONField(name = "mac_addr")
    private String macAddress;

    /**
     * 生产厂家
     */
    @JSONField(name = "vendor")
    private String vendor;

    /**
     * 厂家代号
     */
    @JSONField(name = "vendor_code")
    private String vendorCode;

    /**
     * 硬件版本号
     */
    @JSONField(name = "hardware_version")
    private String hardwareVersion;

    /**
     * 固件版本号
     */
    @JSONField(name = "firmware_version")
    private String firmwareVersion;


    /**
     * 时区, -12~12,如：西9区为 -9
     */
    @JSONField(name = "time_zone")
    private int timeZone;

    /**
     * 生产时间
     */
    @JSONField(name = "prod_time")
    private Date productTime;

    /**
     * 产品信息,JSONObject
     * name:string:产品名称
     * code:string:产品代号
     * category:string:产品类型
     * version:string:产品版本
     */
    @JSONField(name = "product")
    private JSONObject product;

    /**
     * 设备详情（根据不同的产品，详情格式不同）
     * attr:array<object>:设备属性
     * key:string:属性键(Rcmp, 颜色， 尺码)
     * value:string:属性值
     */
    @JSONField(name = "info")
    private JSONObject info;

    /**
     * 绑定信息
     * operator:object:操作人信息
     * - creator:long:创建者ID
     * - creator_name:string:创建者名称
     * - creator_time:date:创建时间
     * bind_time:date:绑定时间
     */
    @JSONField(name = "bind")
    private BindInfo bind;

    public static class BindInfo {
        /**
         * 绑定时间
         */
        @JSONField(name = "bind_time")
        private Date bindTime;

        /**
         * 操作人信息
         */
        @JSONField(name = "operator")
        private OperatorInfo operator;

        public Date getBindTime() {
            return bindTime;
        }

        public void setBindTime(Date bindTime) {
            this.bindTime = bindTime;
        }

        public OperatorInfo getOperator() {
            return operator;
        }

        public void setOperator(OperatorInfo operator) {
            this.operator = operator;
        }
    }

    /**
     * 操作人信息
     */
    public static class OperatorInfo {
        /**
         * 创建者ID
         */
        @JSONField(name = "creator")
        private long creator;
        /**
         * 创建者名称
         */
        @JSONField(name = "creator_name")
        private String creatorName;
        /**
         * 创建时间
         */
        @JSONField(name = "creator_time")
        private Date creatorTime;

        public long getCreator() {
            return creator;
        }

        public void setCreator(long creator) {
            this.creator = creator;
        }

        public String getCreatorName() {
            return creatorName;
        }

        public void setCreatorName(String creatorName) {
            this.creatorName = creatorName;
        }

        public Date getCreatorTime() {
            return creatorTime;
        }

        public void setCreatorTime(Date creatorTime) {
            this.creatorTime = creatorTime;
        }
    }

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getVcode() {
        return vcode;
    }

    public void setVcode(String vcode) {
        this.vcode = vcode;
    }

    public String getMacAddress() {
        return macAddress;
    }

    public void setMacAddress(String macAddress) {
        this.macAddress = macAddress;
    }

    public String getHardwareVersion() {
        return hardwareVersion;
    }

    public void setHardwareVersion(String hardwareVersion) {
        this.hardwareVersion = hardwareVersion;
    }

    public String getFirmwareVersion() {
        return firmwareVersion;
    }

    public void setFirmwareVersion(String firmwareVersion) {
        this.firmwareVersion = firmwareVersion;
    }

    public String getVendor() {
        return vendor;
    }

    public void setVendor(String vendor) {
        this.vendor = vendor;
    }

    public String getVendorCode() {
        return vendorCode;
    }

    public void setVendorCode(String vendorCode) {
        this.vendorCode = vendorCode;
    }

    public int getTimeZone() {
        return timeZone;
    }

    public void setTimeZone(int timeZone) {
        this.timeZone = timeZone;
    }

    public Date getProductTime() {
        return productTime;
    }

    public void setProductTime(Date productTime) {
        this.productTime = productTime;
    }

    public JSONObject getProduct() {
        return product;
    }

    public void setProduct(JSONObject product) {
        this.product = product;
    }

    public JSONObject getInfo() {
        return info;
    }

    public void setInfo(JSONObject info) {
        this.info = info;
    }

    public BindInfo getBind() {
        return bind;
    }

    public void setBind(BindInfo bind) {
        this.bind = bind;
    }
}
