package hk.advanpro.cloud.api.result.msg;

import com.alibaba.fastjson.annotation.JSONField;

import java.io.Serializable;
import java.util.Date;

/**
 * 我的消息
 * Created by jason on 2019/6/11
 */
public class MessageResult implements Serializable {

    @JSONField(name = "id")
    private String id;

    private String title;

    private String sub_title;

    private String content;

    /**
     * 消息类型
     * - text 文本
     * - url 超链接
     */
    private String type;

    /**
     * 状态
     * - 1:未读
     * - 2:已读
     * - 3:删除
     */
    private int status;

    /**
     * 附加信息
     */
    @JSONField(name = "extras")
    private Extras extras;

    @JSONField(name = "operator")
    private Operator operator;

    public static class Extras implements Serializable {
        private String category;
        private String type;
        private String url;
        private String id;

        @JSONField(name = "msg_id")
        private String msgId;

        public String getCategory() {
            return category;
        }

        public void setCategory(String category) {
            this.category = category;
        }

        public String getType() {
            return type;
        }

        public void setType(String type) {
            this.type = type;
        }

        public String getUrl() {
            return url;
        }

        public void setUrl(String url) {
            this.url = url;
        }

        public String getId() {
            return id;
        }

        public void setId(String id) {
            this.id = id;
        }

        public String getMsgId() {
            return msgId;
        }

        public void setMsgId(String msgId) {
            this.msgId = msgId;
        }
    }

    public static class Operator implements Serializable {
        /**
         * 创建时间
         */
        @JSONField(name = "creator_time")
        private Date creatorTime;

        public Date getCreatorTime() {
            return creatorTime;
        }

        public void setCreatorTime(Date creatorTime) {
            this.creatorTime = creatorTime;
        }
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getSub_title() {
        return sub_title;
    }

    public void setSub_title(String sub_title) {
        this.sub_title = sub_title;
    }

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public int getStatus() {
        return status;
    }

    public void setStatus(int status) {
        this.status = status;
    }

    public Extras getExtras() {
        return extras;
    }

    public void setExtras(Extras extras) {
        this.extras = extras;
    }

    public Operator getOperator() {
        return operator;
    }

    public void setOperator(Operator operator) {
        this.operator = operator;
    }
}


