package hk.advanpro.cloud.api.result.oc;

import com.alibaba.fastjson.annotation.JSONField;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * 商品评价
 */
public class CommentResult implements Serializable {
    /**
     * 评论主键
     */
    private long id;
    /**
     * 用户名称
     */
    @JSONField(name = "create_name")
    private String createName;
    /**
     * 评价时间
     */
    @JSONField(name = "create_time")
    private Date createTime;
    /**
     * 评价内容
     */
    @JSONField(name = "content")
    private String content;
    /**
     * 评价图片url数组
     */
    @JSONField(name = "photos")
    private String photos;
    /**
     * 回复内容
     */
    @JSONField(name = "reply")
    private Reply reply;
    /**
     * 商品快照内容
     */
    @JSONField(name = "display_snapshot")
    private DisplaySnapshotResult displaySnapshot;

    public static class Reply {
        /**
         * 回复内容
         */
        private String content;
        /**
         * 回复图片url数组
         */
        @JSONField(name = "photos")
        private List<String> photos;
        /**
         * 回复时间
         */
        @JSONField(name = "create_time")
        private Date createTime;

        public String getContent() {
            return content;
        }

        public void setContent(String content) {
            this.content = content;
        }

        public List<String> getPhotos() {
            return photos;
        }

        public void setPhotos(List<String> photos) {
            this.photos = photos;
        }

        public Date getCreateTime() {
            return createTime;
        }

        public void setCreateTime(Date createTime) {
            this.createTime = createTime;
        }
    }

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public String getCreateName() {
        return createName;
    }

    public void setCreateName(String createName) {
        this.createName = createName;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
    }

    public String getPhotos() {
        return photos;
    }

    public void setPhotos(String photos) {
        this.photos = photos;
    }

    public Reply getReply() {
        return reply;
    }

    public void setReply(Reply reply) {
        this.reply = reply;
    }

    public DisplaySnapshotResult getDisplaySnapshot() {
        return displaySnapshot;
    }

    public void setDisplaySnapshot(DisplaySnapshotResult displaySnapshot) {
        this.displaySnapshot = displaySnapshot;
    }
}
