package hk.advanpro.cloud.api.result.oc;

import java.io.Serializable;
import java.util.List;

/**
 * 物流详情
 */
public class LogisticResult implements Serializable {
    private String logistic_code;// 运单号
    private String shipper_code;// 物流公司编码
    private String shipper_name;//物流公司名称
    private String sign_date;// 签收日期
    /**
     * 物流状态
     * 0-无轨迹
     * 1-已揽收
     * 2-在途中
     * 3-签收
     * 4-问题件
     */
    private String state;
    private boolean success;// 查询是否成功

    /**
     * 物流事件
     */
    private List<Action> traces;

    public static class Action {
        private String accept_station;// 物流事件
        private String accept_time;// 发生时间

        public String getAccept_station() {
            return accept_station;
        }

        public void setAccept_station(String accept_station) {
            this.accept_station = accept_station;
        }

        public String getAccept_time() {
            return accept_time;
        }

        public void setAccept_time(String accept_time) {
            this.accept_time = accept_time;
        }
    }

    public String getLogistic_code() {
        return logistic_code;
    }

    public void setLogistic_code(String logistic_code) {
        this.logistic_code = logistic_code;
    }

    public String getShipper_code() {
        return shipper_code;
    }

    public void setShipper_code(String shipper_code) {
        this.shipper_code = shipper_code;
    }

    public String getShipper_name() {
        return shipper_name;
    }

    public void setShipper_name(String shipper_name) {
        this.shipper_name = shipper_name;
    }

    public String getSign_date() {
        return sign_date;
    }

    public void setSign_date(String sign_date) {
        this.sign_date = sign_date;
    }

    public String getState() {
        return state;
    }

    public void setState(String state) {
        this.state = state;
    }

    public boolean isSuccess() {
        return success;
    }

    public void setSuccess(boolean success) {
        this.success = success;
    }

    public List<Action> getTraces() {
        return traces;
    }

    public void setTraces(List<Action> traces) {
        this.traces = traces;
    }
}
