package hk.advanpro.cloud.api.result.oc;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.annotation.JSONField;

import java.io.Serializable;
import java.util.List;

public class ProductDetailResult implements Serializable {

    private long id;
    /**
     * 商品名称
     */
    private String title;
    /**
     * 商品分类名称
     */
    private String category;
    /**
     * 商品属性 ，格式如：({"机身颜色":["金色","金色"], "网络类型":["4G","3G"],"存储容量":["64G","32G"] })
     */
    private JSONObject attrs;
    /**
     * 商品图片数组 第一张为主图；第二张为缩略图；后面的为商品图片
     */
    private List<String> photos;
    @JSONField(name = "total_sales")
    private int totalSales;
    /**
     * 商品详情URL  放OSS
     */
    @JSONField(name = "detail_url")
    private String detailUrl;
    /**
     * 商品指导价格
     */
    private float price;

    /**
     * 运费
     */
    @JSONField(name = "post_fee")
    private float postFee;


    /**
     * 商品库存
     */
    public static class ProduceSkus {
        private long id;
        /**
         * 商品属性 格式如：({"机身颜色":"金色", "网络类型":"移动双4G","存储容量":"64G" })
         */
        private JSONObject attrs;
        /**
         * 数量
         */
        private int quantity;
        /**
         * 价格
         */
        private float price;

        public long getId() {
            return id;
        }

        public void setId(long id) {
            this.id = id;
        }

        public JSONObject getAttrs() {
            return attrs;
        }

        public void setAttrs(JSONObject attrs) {
            this.attrs = attrs;
        }

        public int getQuantity() {
            return quantity;
        }

        public void setQuantity(int quantity) {
            this.quantity = quantity;
        }

        public float getPrice() {
            return price;
        }

        public void setPrice(float price) {
            this.price = price;
        }
    }
}
