package hk.advanpro.cloud.api.result.qc;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.annotation.JSONField;

import java.io.Serializable;

/**
 * 某个订单的设备列表
 * Created by jason on 2018/7/18
 */
public class DeviceResult implements Serializable {

    private String id;

    private String code;

    private String vcode;

    @JSONField(name = "mac_addr")
    private String macAddress;

    private String vendor;

    @JSONField(name = "vendor_code")
    private String vendorCode;

    @JSONField(name = "time_zone")
    private String timeZone;

    @JSONField(name = "prod_time")
    private String prodTime;

    private Product product;

    private JSONObject info;

    private Bind bind;

    /**
     * 状态
     * -1: 待检测
     * -2：合格
     * -3：不合格
     */
    private int status;

    /**
     * 写入硬件状态
     * -0：未写入
     * -1：已写入
     */
    @JSONField(name = "write_status")
    private int writeStatus;

    public int getWriteStatus() {
        return writeStatus;
    }

    public void setWriteStatus(int writeStatus) {
        this.writeStatus = writeStatus;
    }

    public int getStatus() {

        return status;
    }

    public void setStatus(int status) {
        this.status = status;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getVcode() {
        return vcode;
    }

    public void setVcode(String vcode) {
        this.vcode = vcode;
    }

    public String getMacAddress() {
        return macAddress;
    }

    public void setMacAddress(String macAddress) {
        this.macAddress = macAddress;
    }

    public String getVendor() {
        return vendor;
    }

    public void setVendor(String vendor) {
        this.vendor = vendor;
    }

    public String getVendorCode() {
        return vendorCode;
    }

    public void setVendorCode(String vendorCode) {
        this.vendorCode = vendorCode;
    }

    public String getTimeZone() {
        return timeZone;
    }

    public void setTimeZone(String timeZone) {
        this.timeZone = timeZone;
    }

    public String getProdTime() {
        return prodTime;
    }

    public void setProdTime(String prodTime) {
        this.prodTime = prodTime;
    }

    public Product getProduct() {
        return product;
    }

    public void setProduct(Product product) {
        this.product = product;
    }

    public JSONObject getInfo() {
        return info;
    }

    public void setInfo(JSONObject info) {
        this.info = info;
    }

    public Bind getBind() {
        return bind;
    }

    public void setBind(Bind bind) {
        this.bind = bind;
    }

    public static class Product {
        private String name;
        private String code;
        private Object category;
        private String version;

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }

        public String getCode() {
            return code;
        }

        public void setCode(String code) {
            this.code = code;
        }

        public Object getCategory() {
            return category;
        }

        public void setCategory(Object category) {
            this.category = category;
        }

        public String getVersion() {
            return version;
        }

        public void setVersion(String version) {
            this.version = version;
        }
    }

    public static class Bind {
        @JSONField(name = "bind_time")
        private String bindTime;

        private Operator operator;

        public String getBindTime() {
            return bindTime;
        }

        public void setBindTime(String bindTime) {
            this.bindTime = bindTime;
        }

        public Operator getOperator() {
            return operator;
        }

        public void setOperator(Operator operator) {
            this.operator = operator;
        }
    }

    public static class Operator {
        /**
         * 创建者
         */
        @JSONField(name = "creator")
        private long creator;

        /**
         * 创建者名称
         */
        @JSONField(name = "creator_name")
        private String creatorName;

        /**
         * 创建时间
         */
        @JSONField(name = "creator_time")
        private String creatorTime;

        public long getCreator() {
            return creator;
        }

        public void setCreator(long creator) {
            this.creator = creator;
        }

        public String getCreatorName() {
            return creatorName;
        }

        public void setCreatorName(String creatorName) {
            this.creatorName = creatorName;
        }

        public String getCreatorTime() {
            return creatorTime;
        }

        public void setCreatorTime(String creatorTime) {
            this.creatorTime = creatorTime;
        }
    }


}
