package hk.advanpro.cloud.api.result.qc;

import com.alibaba.fastjson.annotation.JSONField;

import java.io.Serializable;
import java.util.List;

/**
 * 获取订单列表
 * Created by jason on 2018/7/18
 */
public class OrderResult implements Serializable {

    private String id;

    @JSONField(name = "order_no")
    private String orderId;

    @JSONField(name = "product")
    private Product product;

    /**
     * :订单类型，0，设计实验阶段，1，试生产阶段，2量产阶段
     */
    private int type;

    @JSONField(name = "factory")
    private Factory factory;

    @JSONField(name = "projects")
    private List<Project> projects;

    private int number;

    @JSONField(name = "min_number")
    private int minNumber;

    @JSONField(name = "max_number")
    private int maxNumber;

    /**
     * 设备编码取值范围
     */
    @JSONField(name = "product_code")
    private String productCode;

    private Operator operator;

    public String getProductCode() {
        return productCode;
    }

    public void setProductCode(String productCode) {
        this.productCode = productCode;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getOrderId() {
        return orderId;
    }

    public void setOrderId(String orderId) {
        this.orderId = orderId;
    }

    public Product getProduct() {
        return product;
    }

    public void setProduct(Product product) {
        this.product = product;
    }

    public int getType() {
        return type;
    }

    public void setType(int type) {
        this.type = type;
    }

    public Factory getFactory() {
        return factory;
    }

    public void setFactory(Factory factory) {
        this.factory = factory;
    }

    public List<Project> getProjects() {
        return projects;
    }

    public void setProjects(List<Project> projects) {
        this.projects = projects;
    }

    public int getNumber() {
        return number;
    }

    public void setNumber(int number) {
        this.number = number;
    }

    public int getMinNumber() {
        return minNumber;
    }

    public void setMinNumber(int minNumber) {
        this.minNumber = minNumber;
    }

    public int getMaxNumber() {
        return maxNumber;
    }

    public void setMaxNumber(int maxNumber) {
        this.maxNumber = maxNumber;
    }

    public Operator getOperator() {
        return operator;
    }

    public void setOperator(Operator operator) {
        this.operator = operator;
    }

    public static class Product {
        private Object category;
        private String name;
        private String code;
        private String version;

        public Object getCategory() {
            return category;
        }

        public void setCategory(Object category) {
            this.category = category;
        }

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }

        public String getCode() {
            return code;
        }

        public void setCode(String code) {
            this.code = code;
        }

        public String getVersion() {
            return version;
        }

        public void setVersion(String version) {
            this.version = version;
        }
    }

    public static class Factory {
        private String id;
        private String name;
        private String code;

        public String getId() {
            return id;
        }

        public void setId(String id) {
            this.id = id;
        }

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }

        public String getCode() {
            return code;
        }

        public void setCode(String code) {
            this.code = code;
        }
    }

    public static class Project {
        @JSONField(name = "id")
        private String id;

        private String name;

        @JSONField(name = "_id")
        private String sId;

        public String getId() {
            return id;
        }

        public void setId(String id) {
            this.id = id;
        }

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }

        public String getsId() {
            return sId;
        }

        public void setsId(String sId) {
            this.sId = sId;
        }
    }

    public static class Operator {
        /**
         * 创建者
         */
        @JSONField(name = "creator")
        private long creator;

        /**
         * 创建者名称
         */
        @JSONField(name = "creator_name")
        private String creatorName;

        /**
         * 创建时间
         */
        @JSONField(name = "creator_time")
        private String creatorTime;

        public long getCreator() {
            return creator;
        }

        public void setCreator(long creator) {
            this.creator = creator;
        }

        public String getCreatorName() {
            return creatorName;
        }

        public void setCreatorName(String creatorName) {
            this.creatorName = creatorName;
        }

        public String getCreatorTime() {
            return creatorTime;
        }

        public void setCreatorTime(String creatorTime) {
            this.creatorTime = creatorTime;
        }
    }
}
