package hk.advanpro.cloud.api.result.sac;

import com.alibaba.fastjson.annotation.JSONField;

import java.io.Serializable;
import java.util.Date;

/**
 * Created by jalin on 2017/10/13.
 */

public class RunStatisticResult implements Serializable {
    @JSONField(name = "begin_time")
    private Date beginTime;

    @JSONField(name = "end_time")
    private Date endTime;

    @JSONField(name = "duration")
    private int duration;

    @JSONField(name = "distance")
    private double distance;

    @JSONField(name = "avg_speed")
    private int avgSpeed;

    @JSONField(name = "step_freq")
    private int stepFreq;

    @JSONField(name = "total_calorie")
    private double totalCalorie;

    @JSONField(name = "count")
    private int count;

    @JSONField(name = "main_land")
    private int mainLand;

    @JSONField(name = "land_percent")
    private float landPercent;

    @JSONField(name = "main_rotation")
    private int mainRotation;

    @JSONField(name = "rotation_percent")
    private float rotationPercent;

    public Date getBeginTime() {
        return beginTime;
    }

    public void setBeginTime(Date beginTime) {
        this.beginTime = beginTime;
    }

    public Date getEndTime() {
        return endTime;
    }

    public void setEndTime(Date endTime) {
        this.endTime = endTime;
    }

    public int getDuration() {
        return duration;
    }

    public void setDuration(int duration) {
        this.duration = duration;
    }

    public double getDistance() {
        return distance;
    }

    public void setDistance(double distance) {
        this.distance = distance;
    }

    public int getAvgSpeed() {
        return avgSpeed;
    }

    public void setAvgSpeed(int avgSpeed) {
        this.avgSpeed = avgSpeed;
    }

    public int getStepFreq() {
        return stepFreq;
    }

    public void setStepFreq(int stepFreq) {
        this.stepFreq = stepFreq;
    }

    public double getTotalCalorie() {
        return totalCalorie;
    }

    public void setTotalCalorie(double totalCalorie) {
        this.totalCalorie = totalCalorie;
    }

    public int getCount() {
        return count;
    }

    public void setCount(int count) {
        this.count = count;
    }

    /**
     * 主要着地方式
     * - 0：全掌着地
     - 1：前掌着地
     - 2：脚跟着地
     - 3：无数据
     * @return 主要着地方式
     */
    public int getMainLand() {
        return mainLand;
    }

    public void setMainLand(int mainLand) {
        this.mainLand = mainLand;
    }

    /**
     * 主要着地方式占比(无数据时值为100)
     * @return float
     */
    public float getLandPercent() {
        return landPercent;
    }

    public void setLandPercent(float landPercent) {
        this.landPercent = landPercent;
    }

    /**
     * 主要足内旋
     - 0：正常
     - 1：内翻
     - 2：外翻
     - 3：无数据
     * @return 主要足内旋
     */
    public int getMainRotation() {
        return mainRotation;
    }

    public void setMainRotation(int mainRotation) {
        this.mainRotation = mainRotation;
    }

    /**
     * 主要足内旋占比(无数据时值为100)
     * @return 主要足内旋占比
     */
    public float getRotationPercent() {
        return rotationPercent;
    }

    public void setRotationPercent(float rotationPercent) {
        this.rotationPercent = rotationPercent;
    }
}
