package hk.advanpro.cloud.api.result.soc;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.annotation.JSONField;

import org.apache.commons.lang3.StringUtils;

import java.io.Serializable;

/**
 * 获取我的粉丝/关注/举报/拉黑列表
 * Created by jason on 2018/7/3
 */
public class FollowerPeoplesResult implements Serializable {
    /**
     * 社交主键
     */
    @JSONField(name = "id")
    private String id;

    /**
     * uc主键
     */
    @JSONField(name = "uc_id")
    private Object ucId;


    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    private JSONObject extras;


    public boolean isHasFollow() {
        if (extras != null && extras.containsKey("has_follow"))
            return extras.getBoolean("has_follow");
        return false;
    }

    public String getNote() {
        if (extras != null && extras.containsKey("note"))
            return extras.getString("note");
        return "";
    }

    public String getContactName() {
        String note = getNote();
        if (StringUtils.isNotEmpty(note)) {
            return note;
        } else if (getUserInfo() != null) {
            return getUserInfo().getNickName();
        }
        return "";
    }

    public void setHasFollow(boolean hasFollow) {
        if (extras == null) {
            extras = new JSONObject();
        }
        extras.put("has_follow", hasFollow);

    }

    public Object getUcId() {
        return ucId;
    }

    public UserInfo userinfo;

    @JSONField(serialize = false)
    public UserInfo getUserInfo() {
        if (userinfo == null && getUcId() != null && getUcId() instanceof JSONObject) {
            userinfo = ((JSONObject) getUcId()).toJavaObject(UserInfo.class);
        }
        return userinfo;

    }

    @JSONField(serialize = false)
    public String getNickName() {
        if (getUserInfo() != null) {
            return getUserInfo().getNickName();
        }
        return "";
    }

    @JSONField(serialize = false)
    public String getPhoto() {
        if (getUserInfo() != null) {
            return getUserInfo().getPhoto();
        }
        return "";
    }

    public void setUcId(Object ucId) {
        this.ucId = ucId;
    }

    public JSONObject getExtras() {
        return extras;
    }

    public void setExtras(JSONObject extras) {
        this.extras = extras;
    }
}
