package hk.advanpro.cloud.api.result.soc;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.annotation.JSONField;

import java.util.Date;

/**
 * 互动消息
 * Created by jason on 2018/9/19
 */
public class InteractiveMessageResult {

    public static final String SOC_FOLLOW = "SOC_FOLLOW"; //关注
    public static final String SOC_COMMENT = "SOC_COMMENT"; //评论
    public static final String SOC_PRAISE = "SOC_PRAISE"; //点赞了帖子
    public static final String SOC_SHARE = "SOC_SHARE"; //分享
    public static final String SOC_STORE = "SOC_STORE"; //收藏
    public static final String SOC_CANCEL_FOLLOW = "SOC_CANCEL_FOLLOW"; //取消关注
    public static final String SOC_DISS = "SOC_DISS"; //踩
    public static final String SOC_PRAISE_COMMENT = "SOC_PRAISE_COMMENT";//点赞了评论

    @JSONField(name = "id")
    private String id;

    @JSONField(name = "sender_id")
    private String senderId;

    @JSONField(name = "receiver_id")
    private String receiverId;

    @JSONField(name = "action")
    private String action;

    @JSONField(name = "create_time")
    private Date createTime;

    @JSONField(name = "data")
    private MixData data;

    public static class MixData {
        /**
         * 帖子信息
         */
        @JSONField(name = "post")
        private Object post;

        /**
         * 回复内容
         */
        @JSONField(name = "comment")
        private Object comment;

        /**
         * 用户信息
         */
        @JSONField(name = "user")
        private Object user;

        /**
         * 社交ID
         */
        @JSONField(name = "social_id")
        private String socialId;

        /**
         * 被回复人的用户名
         */
        @JSONField(name = "parent_name")
        private String parentName;

        PostsResult postsResult;
        CommentsResult commentsResult;
        UserInfo userInfo;

        @JSONField(serialize = false)
        public PostsResult getPostsResult() {
            if (postsResult == null) {
                if (getPost() != null && getPost() instanceof JSONObject) {
                    postsResult = ((JSONObject) getPost()).toJavaObject(PostsResult.class);
                }
            }
            return postsResult;
        }

        @JSONField(serialize = false)
        public CommentsResult getCommentsResult() {
            if (commentsResult == null) {
                if (getComment() != null && getComment() instanceof JSONObject) {
                    commentsResult = ((JSONObject) getComment()).toJavaObject(CommentsResult.class);
                }
            }
            return commentsResult;
        }

        @JSONField(serialize = false)
        public UserInfo getUserInfo() {
            if (userInfo == null) {
                if (getUser() != null && getUser() instanceof JSONObject) {
                    userInfo = ((JSONObject) getUser()).toJavaObject(UserInfo.class);
                }
            }
            return userInfo;
        }

        public Object getPost() {
            return post;
        }

        public void setPost(Object post) {
            this.post = post;
        }

        public Object getComment() {
            return comment;
        }

        public void setComment(Object comment) {
            this.comment = comment;
        }

        public Object getUser() {
            return user;
        }

        public void setUser(Object user) {
            this.user = user;
        }

        public String getSocialId() {
            return socialId;
        }

        public void setSocialId(String socialId) {
            this.socialId = socialId;
        }

        public String getParentName() {
            return parentName;
        }

        public void setParentName(String parentName) {
            this.parentName = parentName;
        }
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getSenderId() {
        return senderId;
    }

    public void setSenderId(String senderId) {
        this.senderId = senderId;
    }

    public String getReceiverId() {
        return receiverId;
    }

    public void setReceiverId(String receiverId) {
        this.receiverId = receiverId;
    }

    public String getAction() {
        return action;
    }

    public void setAction(String action) {
        this.action = action;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public MixData getData() {
        return data;
    }

    public void setData(MixData data) {
        this.data = data;
    }
}
