package hk.advanpro.cloud.api.result.soc;

import com.alibaba.fastjson.annotation.JSONField;
import com.google.gson.JsonObject;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * 获取个人主页(自己)
 * Created by jason on 2018/7/3
 */
public class MyProfileResult implements Serializable {
    /**
     * 社交主键
     */
    @JSONField(name = "id")
    private String id;

    /**
     * UC主键
     */
    @JSONField(name = "uc_id")
    private String ucId;

    /**
     * 角色
     */
    @JSONField(name = "roles")
    private List<Roles> roles;

    /**
     * 推荐人
     */
    @JSONField(name = "from_user")
    private long fromUser;

    /**
     * 获取的标签
     */
    @JSONField(name = "tags")
    private List<Tags> tags;

    /**
     * 加入的频道
     */
    @JSONField(name = "channels")
    private List<Channels> channels;

    /**
     * 统计信息
     */
    @JSONField(name = "statistics")
    private List<Statistics> statistics;

    /**
     * 社交状态  - 0：禁用； - 1：启用
     */
    @JSONField(name = "status")
    private int status;

    /**
     * 附加信息
     */
    @JSONField(name = "extras")
    private JsonObject extras;

    public static class Roles {

        @JSONField(name = "id")
        private String id;

        @JSONField(name = "name")
        private String name;

        public String getId() {
            return id;
        }

        public void setId(String id) {
            this.id = id;
        }

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }
    }

    public static class Tags {
        /**
         * 标签信息
         */
        @JSONField(name = "tag")
        private List<Tag> tag;

        /**
         * 获取时间
         */
        @JSONField(name = "get_time")
        private Date getTime;

        public List<Tag> getTag() {
            return tag;
        }

        public void setTag(List<Tag> tag) {
            this.tag = tag;
        }

        public Date getGetTime() {
            return getTime;
        }

        public void setGetTime(Date getTime) {
            this.getTime = getTime;
        }

        public static class Tag {
            /**
             * 标签主键
             */
            @JSONField(name = "id")
            private String id;

            /**
             * 标签名称
             */
            @JSONField(name = "name")
            private String name;

            public String getId() {
                return id;
            }

            public void setId(String id) {
                this.id = id;
            }

            public String getName() {
                return name;
            }

            public void setName(String name) {
                this.name = name;
            }
        }


    }

    public static class Channels {
        /**
         * 频道信息
         */
        @JSONField(name = "channel")
        private Channel channel;

        /**
         * 加入时间
         */
        @JSONField(name = "join_time")
        private Date joinTime;

        /**
         * 发帖数
         */
        @JSONField(name = "post_count")
        private int postCount;

        public static class Channel {
            /**
             * 频道主键
             */
            @JSONField(name = "id")
            private String id;

            /**
             * 频道名称
             */
            @JSONField(name = "name")
            private String name;

            public String getId() {
                return id;
            }

            public void setId(String id) {
                this.id = id;
            }

            public String getName() {
                return name;
            }

            public void setName(String name) {
                this.name = name;
            }
        }

        public Channel getChannel() {
            return channel;
        }

        public void setChannel(Channel channel) {
            this.channel = channel;
        }

        public Date getJoinTime() {
            return joinTime;
        }

        public void setJoinTime(Date joinTime) {
            this.joinTime = joinTime;
        }

        public int getPostCount() {
            return postCount;
        }

        public void setPostCount(int postCount) {
            this.postCount = postCount;
        }
    }

    public static class Statistics {
        /**
         * 发帖总数
         */
        @JSONField(name = "post_count")
        private int postCount;

        /**
         * 被举报的次数
         */
        @JSONField(name = "reported_count")
        private int reportedCount;

        /**
         * 被拉黑的次数
         */
        @JSONField(name = "blackened_count")
        private int blackenedCount;

        /**
         * 粉丝人数
         */
        @JSONField(name = "follower_count")
        private int followerCount;

        /**
         * 我关注人数
         */
        @JSONField(name = "following_count")
        private int followingCount;

        public int getPostCount() {
            return postCount;
        }

        public void setPostCount(int postCount) {
            this.postCount = postCount;
        }

        public int getReportedCount() {
            return reportedCount;
        }

        public void setReportedCount(int reportedCount) {
            this.reportedCount = reportedCount;
        }

        public int getBlackenedCount() {
            return blackenedCount;
        }

        public void setBlackenedCount(int blackenedCount) {
            this.blackenedCount = blackenedCount;
        }

        public int getFollowerCount() {
            return followerCount;
        }

        public void setFollowerCount(int followerCount) {
            this.followerCount = followerCount;
        }

        public int getFollowingCount() {
            return followingCount;
        }

        public void setFollowingCount(int followingCount) {
            this.followingCount = followingCount;
        }
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getUcId() {
        return ucId;
    }

    public void setUcId(String ucId) {
        this.ucId = ucId;
    }

    public List<Roles> getRoles() {
        return roles;
    }

    public void setRoles(List<Roles> roles) {
        this.roles = roles;
    }

    public long getFromUser() {
        return fromUser;
    }

    public void setFromUser(long fromUser) {
        this.fromUser = fromUser;
    }

    public List<Tags> getTags() {
        return tags;
    }

    public void setTags(List<Tags> tags) {
        this.tags = tags;
    }

    public List<Channels> getChannels() {
        return channels;
    }

    public void setChannels(List<Channels> channels) {
        this.channels = channels;
    }

    public List<Statistics> getStatistics() {
        return statistics;
    }

    public void setStatistics(List<Statistics> statistics) {
        this.statistics = statistics;
    }

    public int getStatus() {
        return status;
    }

    public void setStatus(int status) {
        this.status = status;
    }

    public JsonObject getExtras() {
        return extras;
    }

    public void setExtras(JsonObject extras) {
        this.extras = extras;
    }
}
