package hk.advanpro.cloud.api.result.soc;

import android.graphics.Color;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.annotation.JSONField;

import org.apache.commons.lang3.StringUtils;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * 获取帖子
 * Created by jason on 2018/7/3
 */
public class PostsResult implements Serializable {

    public static final int CATEGORY_NORMAL = 0;
    public static final int CATEGORY_IMAGE = 1;
    public static final int CATEGORY_QUESTION = 2;
    public static final int CATEGORY_TRAIN = 3;

    /**
     * 帖子主键
     */
    @JSONField(name = "id")
    private String id;

    @JSONField(name = "parent_id")
    private String parentId;

    /**
     * 帖子图标
     */
    @JSONField(name = "icon")
    private String icon;

    /**
     * 帖子标题
     */
    @JSONField(name = "title")
    private String title;

    /**
     * 帖子正文
     */
    @JSONField(name = "text")
    private String text;

    /**
     * 图片
     */
    @JSONField(name = "pictures")
    private List<String> pictures;

    /**
     * 视频
     */
    @JSONField(name = "videos")
    private List<String> videos;

    /**
     * 标签
     */
    @JSONField(name = "symbols")
    private JSONObject symbols;
    /**
     * 吉祥物
     */
    @JSONField(name = "mascot")
    private String mascot;


    /**
     * 是否匿名
     */
    @JSONField(name = "anonymous")
    private Boolean anonymous;

    /**
     * 帖子分类  - 0:文字 - 1:晒图 - 2:提问 - 3:训练
     */
    @JSONField(name = "category")
    private int category;

    /**
     * 帖子类型  - 0:原创  - 1:评论  - 2:转发
     */
    @JSONField(name = "type")
    private int type;

    /**
     * 发布频道
     */
    @JSONField(name = "channels")
    private List<String> channels;

    /**
     * 吉祥物留言
     */
    @JSONField(name = "message")
    private List<String> message;

    /**
     * 附加信息
     */
    @JSONField(name = "extras")
    private Extras extras;

    /**
     * 统计信息
     */
    @JSONField(name = "statistics")
    private Statistics statistics;

    /**
     * 状态 - 0:已删除  - 1:正常 - 2:被屏蔽
     */
    @JSONField(name = "status")
    private int status;

    @JSONField(name = "operator")
    private Operator operator;

    public String getParentId() {
        return parentId;
    }

    public void setParentId(String parentId) {
        this.parentId = parentId;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getIcon() {
        return icon;
    }

    public void setIcon(String icon) {
        this.icon = icon;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getText() {
        return text;
    }

    public void setText(String text) {
        this.text = text;
    }

    public List<String> getPictures() {
        return pictures;
    }

    public void setPictures(List<String> pictures) {
        this.pictures = pictures;
    }

    public List<String> getVideos() {
        return videos;
    }

    public void setVideos(List<String> videos) {
        this.videos = videos;
    }

    public JSONObject getSymbols() {
        return symbols;
    }

    public void setSymbols(JSONObject symbols) {
        this.symbols = symbols;
    }

    public Boolean getAnonymous() {
        return anonymous;
    }

    public void setAnonymous(Boolean anonymous) {
        this.anonymous = anonymous;
    }

    public int getCategory() {
        return category;
    }

    public void setCategory(int category) {
        this.category = category;
    }

    public int getType() {
        return type;
    }

    public void setType(int type) {
        this.type = type;
    }

    public List<String> getChannels() {
        return channels;
    }

    public void setChannels(List<String> channels) {
        this.channels = channels;
    }

    public List<String> getMessage() {
        return message;
    }

    public void setMessage(List<String> message) {
        this.message = message;
    }

    public Extras getExtras() {
        return extras;
    }

    public void setExtras(Extras extras) {
        this.extras = extras;
    }

    public Statistics getStatistics() {
        return statistics;
    }

    public void setStatistics(Statistics statistics) {
        this.statistics = statistics;
    }

    public int getStatus() {
        return status;
    }

    public void setStatus(int status) {
        this.status = status;
    }

    public Operator getOperator() {
        return operator;
    }

    public void setOperator(Operator operator) {
        this.operator = operator;
    }


    public static class Extras implements Serializable {
        @JSONField(name = "has_favor")
        private boolean hasFavor;
        @JSONField(name = "has_collect")
        private boolean hasCollect;
        @JSONField(name = "has_follow")
        private boolean hasFollow;
        @JSONField(name = "has_disslike")
        private boolean hasDisslike;
        @JSONField(name = "titles")
        private List<Title> titles;
        private int total_stars;
        private float progress;
        private int duration;

        public boolean isHasFavor() {
            return hasFavor;
        }

        public void setHasFavor(boolean hasFavor) {
            this.hasFavor = hasFavor;
        }

        public boolean isHasCollect() {
            return hasCollect;
        }

        public void setHasCollect(boolean hasCollect) {
            this.hasCollect = hasCollect;
        }

        public boolean isHasFollow() {
            return hasFollow;
        }

        public void setHasFollow(boolean hasFollow) {
            this.hasFollow = hasFollow;
        }

        public boolean isHasDisslike() {
            return hasDisslike;
        }

        public void setHasDisslike(boolean hasDisslike) {
            this.hasDisslike = hasDisslike;
        }

        public List<Title> getTitles() {
            return titles;
        }

        public void setTitles(List<Title> titles) {
            this.titles = titles;
        }

        public int getTotal_stars() {
            return total_stars;
        }

        public void setTotal_stars(int total_stars) {
            this.total_stars = total_stars;
        }

        public float getProgress() {
            return progress;
        }

        public void setProgress(float progress) {
            this.progress = progress;
        }

        public int getDuration() {
            return duration;
        }

        public void setDuration(int duration) {
            this.duration = duration;
        }
    }

    public static class Title implements Serializable {
        String color;
        String name;

        public String getColor() {
            return color;
        }

        /**
         * 获取颜色值
         *
         * @return
         */
        public int getColorValue() {
            int colorValue = 0;
            try {
                if (StringUtils.isNotEmpty(getColor()))
                    colorValue = Color.parseColor(getColor());

            } catch (Exception e) {
                e.printStackTrace();
            }
            if (colorValue == 0)
                colorValue = Color.parseColor("#67C23A");
            return colorValue;
        }

        public void setColor(String color) {
            this.color = color;
        }

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }
    }

    public static class Statistics implements Serializable {
        /**
         * 被点赞次数
         */
        @JSONField(name = "favored_count")
        private int favorCount;

        /**
         * 被转发次数
         */
        @JSONField(name = "reposted_count")
        private int repostCount;

        /**
         * 被评论次数
         */
        @JSONField(name = "commented_count")
        private int commentCount;

        /**
         * 被举报次数
         */
        @JSONField(name = "reported_count")
        private int reportedCount;

        /**
         * 被收藏次数
         */
        @JSONField(name = "collected_count")
        private int collectCount;

        /**
         * 分享次数
         */
        @JSONField(name = "shared_count")
        private int sharedCount;

        /**
         * 热门评论
         */
        @JSONField(name = "favored_comment")
        private FavoredComment favoredComment;

        public int getFavorCount() {
            return favorCount;
        }

        public void setFavorCount(int favorCount) {
            this.favorCount = favorCount;
        }

        public int getRepostCount() {
            return repostCount;
        }

        public void setRepostCount(int repostCount) {
            this.repostCount = repostCount;
        }

        public int getCommentCount() {
            return commentCount;
        }

        public void setCommentCount(int commentCount) {
            this.commentCount = commentCount;
        }

        public int getReportedCount() {
            return reportedCount;
        }

        public void setReportedCount(int reportedCount) {
            this.reportedCount = reportedCount;
        }

        public int getCollectCount() {
            return collectCount;
        }

        public void setCollectCount(int collectCount) {
            this.collectCount = collectCount;
        }

        public int getSharedCount() {
            return sharedCount;
        }

        public void setSharedCount(int sharedCount) {
            this.sharedCount = sharedCount;
        }

        public FavoredComment getFavoredComment() {
            return favoredComment;
        }

        public void setFavoredComment(FavoredComment favoredComment) {
            this.favoredComment = favoredComment;
        }
    }

    public static class FavoredComment implements Serializable {
        private String text;
        @JSONField(name = "post_id")
        private String postId;
        @JSONField(name = "favored_count")
        private String favoredCount;

        public String getText() {
            return text;
        }

        public void setText(String text) {
            this.text = text;
        }

        public String getPostId() {
            return postId;
        }

        public void setPostId(String postId) {
            this.postId = postId;
        }

        public String getFavoredCount() {
            return favoredCount;
        }

        public void setFavoredCount(String favoredCount) {
            this.favoredCount = favoredCount;
        }
    }

    /**
     * 创建人
     */
    public static class Creator implements Serializable {
        private String photo;
        @JSONField(name = "nick_name")
        private String nickName;
        @JSONField(name = "profiles")
        private UserProfiles profiles;

        public String getPhoto() {
            return photo;
        }

        public void setPhoto(String photo) {
            this.photo = photo;
        }

        public String getNickName() {
            return nickName;
        }

        public void setNickName(String nickName) {
            this.nickName = nickName;
        }

        public UserProfiles getProfiles() {
            return profiles;
        }

        public void setProfiles(UserProfiles profiles) {
            this.profiles = profiles;
        }
    }

    public static class Operator implements Serializable {
        /**
         * 创建者
         */
        @JSONField(name = "creator")
        private Creator creator;

        /**
         * 创建者名称
         */
        @JSONField(name = "creator_name")
        private String creatorName;

        /**
         * 创建时间
         */
        @JSONField(name = "create_time")
        private Date createTime;

        /**
         * 修改者
         */
        @JSONField(name = "modifier")
        private long modifier;

        /**
         * 修改者名称
         */
        @JSONField(name = "modifier_name")
        private String modifierName;

        /**
         * 修改时间
         */
        @JSONField(name = "modify_time")
        private Date modifyTime;
        /**
         * 发布人的social_id
         */
        @JSONField(name = "social_id")
        private String socialId;

        public Creator getCreator() {
            return creator;
        }

        public void setCreator(Creator creator) {
            this.creator = creator;
        }

        public String getCreatorName() {
            return creatorName;
        }

        public void setCreatorName(String creatorName) {
            this.creatorName = creatorName;
        }

        public Date getCreateTime() {
            return createTime;
        }

        public void setCreateTime(Date createTime) {
            this.createTime = createTime;
        }

        public long getModifier() {
            return modifier;
        }

        public void setModifier(long modifier) {
            this.modifier = modifier;
        }

        public String getModifierName() {
            return modifierName;
        }

        public void setModifierName(String modifierName) {
            this.modifierName = modifierName;
        }

        public Date getModifyTime() {
            return modifyTime;
        }

        public void setModifyTime(Date modifyTime) {
            this.modifyTime = modifyTime;
        }

        public String getSocialId() {
            return socialId;
        }

        public void setSocialId(String socialId) {
            this.socialId = socialId;
        }
    }

    /**
     * 最热门的评论
     */
    public String getFavoredCommentText() {
        if (this.getStatistics().getFavoredComment() != null)
            return this.getStatistics().getFavoredComment().getText();
        return "";

    }

    public int getCommentCount() {
        return this.getStatistics().getCommentCount();
    }

    /**
     * 是否点赞点赞了改帖子
     *
     * @return
     */
    public boolean isFavored() {
        if (this.getExtras() != null)
            return this.getExtras().isHasFavor();
        return false;
    }

    /**
     * 设置是否点赞
     *
     * @param isFavored
     */
    public void updateFavored(boolean isFavored) {
        if (this.getExtras() != null)
            this.getExtras().setHasFavor(isFavored);
        this.getStatistics().setFavorCount(this.getStatistics().getFavorCount() + (isFavored ? 1 : -1));
    }

    /**
     * 是否收藏了改帖子
     *
     * @return
     */
    public boolean isCollected() {
        if (this.getExtras() != null)
            return this.getExtras().isHasCollect();
        return false;
    }

    public void addSharedCount() {
        this.getStatistics().setSharedCount(this.getStatistics().getSharedCount() + 1);
    }

    /**
     * 设置是否收藏
     *
     * @param isCollected
     */
    public void updateCollected(boolean isCollected) {
        if (this.getExtras() != null)
            this.getExtras().setHasCollect(isCollected);
        this.getStatistics().setCollectCount(this.getStatistics().getCollectCount() + (isCollected ? 1 : -1));
    }

    /**
     * 更新关注
     *
     * @param isFollow
     */
    public void updateFollow(boolean isFollow) {
        if (this.getExtras() != null)
            this.getExtras().setHasFollow(isFollow);

    }

    public String getMascot() {
        return mascot;
    }

    public void setMascot(String mascot) {
        this.mascot = mascot;
    }

    public String getSocialId() {
        return getOperator().getSocialId();
    }
}
