package hk.advanpro.cloud.api.result.soc;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.annotation.JSONField;

import org.apache.commons.lang3.StringUtils;

/**
 * 孕友之家
 * 一级用户联系人
 *
 * @author jalin
 * created at 2018/9/13
 */
public class PrenatalPeoplesResult {
    /**
     * 社区ID
     */
    private String id;

    @JSONField(name = "uc_id")
    Object ucId;

    JSONObject extras;

    @JSONField(serialize = false)
    UserInfo userInfo;

    public String getNote() {
        if (extras != null && extras.containsKey("note"))
            return extras.getString("note");
        return "";
    }

    public String getContactName() {
        String note = getNote();
        if (StringUtils.isNotEmpty(note)) {
            return note;
        } else if (getUserInfo() != null) {
            return getUserInfo().getNickName();
        }
        return "";
    }

    @JSONField(serialize = false)
    public UserInfo getUserInfo() {
        if (userInfo == null) {
            if (getUcId() != null && getUcId() instanceof JSONObject) {
                userInfo = ((JSONObject) getUcId()).toJavaObject(UserInfo.class);
            }
        }
        return userInfo;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public Object getUcId() {
        return ucId;
    }

    public void setUcId(Object ucId) {
        this.ucId = ucId;
    }

    public JSONObject getExtras() {
        return extras;
    }

    public void setExtras(JSONObject extras) {
        this.extras = extras;
    }
}
