package hk.advanpro.cloud.api.result.soc;

import com.alibaba.fastjson.annotation.JSONField;
import com.google.gson.JsonObject;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * 标签列表
 * Created by jason on 2018/7/3
 */
public class TagsResult implements Serializable {
    private String id;

    @JSONField(name = "app_code")
    private String appCode;

    private String name;

    /**
     * 类型
     * - 0:用户标签
     * - 1:成就
     */
    private int type;

    /**
     * 状态 - 0:禁用  - 1:启用
     */
    @JSONField(name = "status")
    private int status;

    /**
     * 操作用户信息
     */
    @JSONField(name = "operator")
    private List<Operator> operator;

    /**
     * 附加信息
     */
    @JSONField(name = "extras")
    private JsonObject extras;


    public static class Operator {
        /**
         * 创建者
         */
        @JSONField(name = "creator")
        private long creator;

        /**
         * 创建者名称
         */
        @JSONField(name = "creator_name")
        private String creatorName;

        /**
         * 创建时间
         */
        @JSONField(name = "create_time")
        private Date createTime;

        /**
         * 修改者
         */
        @JSONField(name = "modifier")
        private long modifier;

        /**
         * 修改者名称
         */
        @JSONField(name = "modifier_name")
        private String modifierName;

        /**
         * 修改时间
         */
        @JSONField(name = "modify_time")
        private Date modifyTime;

        public long getCreator() {
            return creator;
        }

        public void setCreator(long creator) {
            this.creator = creator;
        }

        public String getCreatorName() {
            return creatorName;
        }

        public void setCreatorName(String creatorName) {
            this.creatorName = creatorName;
        }

        public Date getCreateTime() {
            return createTime;
        }

        public void setCreateTime(Date createTime) {
            this.createTime = createTime;
        }

        public long getModifier() {
            return modifier;
        }

        public void setModifier(long modifier) {
            this.modifier = modifier;
        }

        public String getModifierName() {
            return modifierName;
        }

        public void setModifierName(String modifierName) {
            this.modifierName = modifierName;
        }

        public Date getModifyTime() {
            return modifyTime;
        }

        public void setModifyTime(Date modifyTime) {
            this.modifyTime = modifyTime;
        }
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getAppCode() {
        return appCode;
    }

    public void setAppCode(String appCode) {
        this.appCode = appCode;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getType() {
        return type;
    }

    public void setType(int type) {
        this.type = type;
    }

    public int getStatus() {
        return status;
    }

    public void setStatus(int status) {
        this.status = status;
    }

    public List<Operator> getOperator() {
        return operator;
    }

    public void setOperator(List<Operator> operator) {
        this.operator = operator;
    }

    public JsonObject getExtras() {
        return extras;
    }

    public void setExtras(JsonObject extras) {
        this.extras = extras;
    }
}
