package hk.advanpro.cloud.api.result.soc;

import org.apache.commons.lang3.StringUtils;

import java.io.Serializable;

/**
 * @author jalin
 * created at 2018/9/12
 */
public class UserExtraInfo implements Serializable {
    int is_init;//是否初始化，0未初始化，1已初始化
    int level;//1：级用户，2二级用户
    String device_id = "";//用户初始化时需要绑定的设备ID（临时存储）
    String social_id = "";// 社交主键
    String group_id = "";// 群ID
    String from_user = "";// 邀请人的社交主键
    String role = "";//二级用户角色标签，如：爸爸
    String idcard;//身份证号码

    /**
     * 吉祥物编号
     * 规则如下：
     * A_B_C
     * <p>
     * A: 0生肖、1星座
     * B: 0~11 吉祥物种类（12种）
     * C: 0~2 吉祥物款式 （每种3款）
     */
    String mascot;// 吉祥物编号
    String hospital;// 一级用户产院
    String expected_date;// 一级用户预产期

    String description;// 个人简介
    String bg_img; // 主页背景图片

    // 孕前体重（kg
    float pre_weight;

    public int getIs_init() {
        return is_init;
    }

    public void setIs_init(int is_init) {
        this.is_init = is_init;
    }

    public int getLevel() {
        return level;
    }

    public void setLevel(int level) {
        this.level = level;
    }

    public String getDevice_id() {
        return device_id;
    }

    public void setDevice_id(String device_id) {
        this.device_id = device_id;
    }

    public String getSocial_id() {
        if (StringUtils.isEmpty(social_id)) {
            social_id = "";
        }
        return social_id;
    }

    public void setSocial_id(String social_id) {
        this.social_id = social_id;
    }

    public String getGroup_id() {
        return group_id;
    }

    public void setGroup_id(String group_id) {
        this.group_id = group_id;
    }

    public String getFrom_user() {
        if (StringUtils.isEmpty(from_user)) {
            from_user = "";
        }
        return from_user;
    }

    public void setFrom_user(String from_user) {
        this.from_user = from_user;
    }

    public String getRole() {
        return role;
    }

    public void setRole(String role) {
        this.role = role;
    }

    public String getIdcard() {
        return idcard;
    }

    public void setIdcard(String idcard) {
        this.idcard = idcard;
    }

    public String getMascot() {
        return mascot;
    }

    public void setMascot(String mascot) {
        this.mascot = mascot;
    }

    public String getHospital() {
        return hospital;
    }

    public void setHospital(String hospital) {
        this.hospital = hospital;
    }

    public String getExpected_date() {
        return expected_date;
    }

    public void setExpected_date(String expected_date) {
        this.expected_date = expected_date;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getBg_img() {
        return bg_img;
    }

    public void setBg_img(String bg_img) {
        this.bg_img = bg_img;
    }

    public float getPre_weight() {
        return pre_weight;
    }

    public void setPre_weight(float pre_weight) {
        this.pre_weight = pre_weight;
    }
}
