package hk.advanpro.cloud.api.result.soc;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.annotation.JSONField;
import com.google.gson.JsonObject;

import java.io.Serializable;

/**
 * 获取个人主页(他人)
 * Created by jason on 2018/7/3
 */
public class UserProfileResult implements Serializable {
    /**
     * 社交主键
     */
    @JSONField(name = "id")
    private String id;

    /**
     * UC主键
     */
    @JSONField(name = "uc_id")
    private UserInfo ucId;

    /**
     * 粉丝人数
     */
    @JSONField(name = "follower_count")
    private int followerCount;

    /**
     * 我关注人数
     */
    @JSONField(name = "following_count")
    private int followingCount;

    /**
     * 附加信息
     */
    @JSONField(name = "extras")
    private JSONObject extras;

    /**
     * 状态信息
     */
    @JSONField(name = "statistics")
    private Statistics statistics;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public UserInfo getUcId() {
        return ucId;
    }

    public void setUcId(UserInfo ucId) {
        this.ucId = ucId;
    }

    public int getFollowerCount() {
        return followerCount;
    }

    public void setFollowerCount(int followerCount) {
        this.followerCount = followerCount;
    }

    public int getFollowingCount() {
        return followingCount;
    }

    public void setFollowingCount(int followingCount) {
        this.followingCount = followingCount;
    }

    public JSONObject getExtras() {
        if (extras == null) {
            extras = new JSONObject();
        }
        return extras;
    }

    public void setHasFollow(boolean has_follow) {
        getExtras().put("has_follow", has_follow);
    }

    public boolean getHasFollow() {
        if (!getExtras().containsKey("has_follow")) {
            return false;
        } else {
            return getExtras().getBoolean("has_follow");
        }
    }

    public void setExtras(JSONObject extras) {
        this.extras = extras;
    }

    public Statistics getStatistics() {
        return statistics;
    }

    public void setStatistics(Statistics statistics) {
        this.statistics = statistics;
    }

    public static class Statistics {

        /**
         * 动态条数
         */
        @JSONField(name = "post_count")
        private int postCount;

        /**
         * 粉丝个数
         */
        @JSONField(name = "follower_count")
        private int followerCount;

        /**
         * 关注人个数
         */
        @JSONField(name = "following_count")
        private int followingCount;

        public int getPostCount() {
            return postCount;
        }

        public void setPostCount(int postCount) {
            this.postCount = postCount;
        }

        public int getFollowerCount() {
            return followerCount;
        }

        public void setFollowerCount(int followerCount) {
            this.followerCount = followerCount;
        }

        public int getFollowingCount() {
            return followingCount;
        }

        public void setFollowingCount(int followingCount) {
            this.followingCount = followingCount;
        }
    }
}
