package hk.advanpro.cloud.api.result.uc;

import com.alibaba.fastjson.annotation.JSONField;

import java.io.Serializable;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * 绑定账号列表基本信息
 * Created by yibin on 2017/8/15.
 */

public class AccountAuthResult implements Serializable {
    /**
     * 绑定的账号
     */
    @JSONField(name = "account")
    private String account;

    /**
     * 绑定的账号类型
     * - 1:手机
     * - 2:邮件
     * - 3:微信
     * - 4:QQ
     */
    @JSONField(name = "type")
    private int type;


    /**
     * 绑定账号的信息
     */
    @JSONField(name = "info")
    private Info info;


    /**
     * 绑定的时间
     */
    @JSONField(name = "time")
    private Date time;


    public String getNickName() {
        if (info != null)
            return info.getNickName();
        return "";
    }

    public static class Info {

        @JSONField(name = "nick_name")
        private String nickName;

        @JSONField(name = "photo")
        private String photo;

        public String getNickName() {
            return nickName;
        }

        public void setNickName(String nickName) {
            this.nickName = nickName;
        }

        public String getPhoto() {
            return photo;
        }

        public void setPhoto(String photo) {
            this.photo = photo;
        }
    }

    public String getAccount() {
        return account;
    }

    public void setAccount(String account) {
        this.account = account;
    }

    public int getType() {
        return type;
    }

    public void setType(int type) {
        this.type = type;
    }

    public Info getInfo() {
        return info;
    }

    public void setInfo(Info info) {
        this.info = info;
    }

    public Date getTime() {
        return time;
    }

    public void setTime(Date time) {
        this.time = time;
    }
}
