package hk.advanpro.cloud.api.result.uc;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.annotation.JSONField;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

import hk.advanpro.cloud.api.result.course.TrainClassLocation;

/**
 * 分会信息
 * Created by jason on 2019/7/4
 */
public class BranchResult implements Serializable {

    private String pos_id; //所属服务号
    private int level; //分销等级 1 2 3
    private String id; //分会ID
    private String name; //分会名称
    private String desc; //简介说明
    private List<String> pictures; //简介图片
    private Coach admin; //会长信息
    private TrainClassLocation localtion; //位置信息
    private int type; //主体类型 1:个人 2:企业
    private String real_name; //企业名称 或 个人名称
    private String phone; //联系电话
    private List<String> cert_photos; //证件照片
    private int effective_type; // - 1:具体时间 - 2:永久有效
    private String effective_time; //有效日期
    private int number; //分会人数

    /**
     * 状态
     * - 0:禁用
     * - 1:正常
     * - 2:申请中
     * - 3:审核不通过
     */
    private int status;

    private MemberInfo member;

    /**
     * 显示权限
     * - 1:开放
     * - 2:个人私有 不显示给外界看
     */
    private int ownership;

    /**
     * 额外内容
     * is_admin:boolean:当前用户是否是会长
     */
    private JSONObject extras;

    private OperatorInfo operator;

    /**
     * 分会成员
     */
    public static class MemberInfo {
        private List<Coach> joined; //加入的分会成员
        private List<Coach> apply; //申请加入分会成员 等待同意
        private List<Coach> leave; //申请退出的分会成员 等待同意

        public List<Coach> getJoined() {
            return joined;
        }

        public void setJoined(List<Coach> joined) {
            this.joined = joined;
        }

        public List<Coach> getApply() {
            return apply;
        }

        public void setApply(List<Coach> apply) {
            this.apply = apply;
        }

        public List<Coach> getLeave() {
            return leave;
        }

        public void setLeave(List<Coach> leave) {
            this.leave = leave;
        }
    }

    public static class Coach {
        private String _id;
        private String id; //用户ID
        private String name; //用户名称
        private String phone; //电话
        private String photo; //用户头像
        private Date time; //加入时间
        private String sex;
        private int level;

        public String getId() {
            return id;
        }

        public void setId(String id) {
            this.id = id;
        }

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }

        public String getPhone() {
            return phone;
        }

        public void setPhone(String phone) {
            this.phone = phone;
        }

        public String getPhoto() {
            return photo;
        }

        public void setPhoto(String photo) {
            this.photo = photo;
        }

        public Date getTime() {
            return time;
        }

        public void setTime(Date time) {
            this.time = time;
        }

        public String get_id() {
            return _id;
        }

        public void set_id(String _id) {
            this._id = _id;
        }

        public String getSex() {
            return sex;
        }

        public void setSex(String sex) {
            this.sex = sex;
        }

        public int getLevel() {
            return level;
        }

        public void setLevel(int level) {
            this.level = level;
        }
    }

    /**
     * 操作人信息
     */
    public static class OperatorInfo {
        /**
         * 创建者ID
         */
        @JSONField(name = "creator")
        private long creator;
        /**
         * 创建者名称
         */
        @JSONField(name = "creator_name")
        private String creatorName;
        /**
         * 创建时间
         */
        @JSONField(name = "creator_time")
        private Date creatorTime;

        public long getCreator() {
            return creator;
        }

        public void setCreator(long creator) {
            this.creator = creator;
        }

        public String getCreatorName() {
            return creatorName;
        }

        public void setCreatorName(String creatorName) {
            this.creatorName = creatorName;
        }

        public Date getCreatorTime() {
            return creatorTime;
        }

        public void setCreatorTime(Date creatorTime) {
            this.creatorTime = creatorTime;
        }
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getPos_id() {
        return pos_id;
    }

    public void setPos_id(String pos_id) {
        this.pos_id = pos_id;
    }

    public int getLevel() {
        return level;
    }

    public void setLevel(int level) {
        this.level = level;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDesc() {
        return desc;
    }

    public void setDesc(String desc) {
        this.desc = desc;
    }

    public List<String> getPictures() {
        return pictures;
    }

    public void setPictures(List<String> pictures) {
        this.pictures = pictures;
    }

    public Coach getAdmin() {
        return admin;
    }

    public void setAdmin(Coach admin) {
        this.admin = admin;
    }

    public TrainClassLocation getLocaltion() {
        return localtion;
    }

    public void setLocaltion(TrainClassLocation localtion) {
        this.localtion = localtion;
    }

    public int getType() {
        return type;
    }

    public void setType(int type) {
        this.type = type;
    }

    public String getReal_name() {
        return real_name;
    }

    public void setReal_name(String real_name) {
        this.real_name = real_name;
    }

    public String getPhone() {
        return phone;
    }

    public void setPhone(String phone) {
        this.phone = phone;
    }

    public List<String> getCert_photos() {
        return cert_photos;
    }

    public void setCert_photos(List<String> cert_photos) {
        this.cert_photos = cert_photos;
    }

    public int getEffective_type() {
        return effective_type;
    }

    public void setEffective_type(int effective_type) {
        this.effective_type = effective_type;
    }

    public String getEffective_time() {
        return effective_time;
    }

    public void setEffective_time(String effective_time) {
        this.effective_time = effective_time;
    }

    public int getNumber() {
        return number;
    }

    public void setNumber(int number) {
        this.number = number;
    }

    public int getStatus() {
        return status;
    }

    public void setStatus(int status) {
        this.status = status;
    }

    public MemberInfo getMember() {
        return member;
    }

    public void setMember(MemberInfo member) {
        this.member = member;
    }

    public OperatorInfo getOperator() {
        return operator;
    }

    public void setOperator(OperatorInfo operator) {
        this.operator = operator;
    }

    public int getOwnership() {
        return ownership;
    }

    public void setOwnership(int ownership) {
        this.ownership = ownership;
    }

    public JSONObject getExtras() {
        return extras;
    }

    public void setExtras(JSONObject extras) {
        this.extras = extras;
    }
}
