package hk.advanpro.cloud.api.result.uc;

import java.io.Serializable;
import java.util.Date;

/**
 * 分会教练
 * Created by jason on 2019/7/4
 */
public class CoachResult implements Serializable {

    private String id; //教练id
    private String name; //真实姓名
    private String photo; //头像
    private String phone;
    private String sex; //性别(N:未知，M:男,F:女)
    private Date date;
    private String desc; //申请加入/退出说明

    /**
     * 教练等级
     * 1:大中华区域认证教练 2:国际认证教练 3:资深国际认证教练 4:大师级教练
     */
    private int level;

    private ExtrasInfo extras;

    public static class ExtrasInfo {
        private int month_count; //本月开课数量
        private int total_count; //总开课数量
        private int waiting_count; //待开课数量
        private int dms_waiting_count; //分会中待完成数量

        public int getMonth_count() {
            return month_count;
        }

        public void setMonth_count(int month_count) {
            this.month_count = month_count;
        }

        public int getTotal_count() {
            return total_count;
        }

        public void setTotal_count(int total_count) {
            this.total_count = total_count;
        }

        public int getWaiting_count() {
            return waiting_count;
        }

        public void setWaiting_count(int waiting_count) {
            this.waiting_count = waiting_count;
        }

        public int getDms_waiting_count() {
            return dms_waiting_count;
        }

        public void setDms_waiting_count(int dms_waiting_count) {
            this.dms_waiting_count = dms_waiting_count;
        }
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getPhoto() {
        return photo;
    }

    public void setPhoto(String photo) {
        this.photo = photo;
    }

    public String getSex() {
        return sex;
    }

    public void setSex(String sex) {
        this.sex = sex;
    }

    public int getLevel() {
        return level;
    }

    public void setLevel(int level) {
        this.level = level;
    }

    public ExtrasInfo getExtras() {
        return extras;
    }

    public void setExtras(ExtrasInfo extras) {
        this.extras = extras;
    }

    public String getPhone() {
        return phone;
    }

    public void setPhone(String phone) {
        this.phone = phone;
    }

    public Date getDate() {
        return date;
    }

    public void setDate(Date date) {
        this.date = date;
    }

    public String getDesc() {
        return desc;
    }

    public void setDesc(String desc) {
        this.desc = desc;
    }
}
