package hk.advanpro.cloud.api;

import com.alibaba.fastjson.JSON;

import org.junit.Assert;
import org.junit.BeforeClass;
import org.junit.Test;


import hk.advanpro.cloud.android.CloudService;
import hk.advanpro.cloud.android.model.CloudAddressType;
import hk.advanpro.cloud.android.model.UserAgent;
import hk.advanpro.cloud.api.result.RestfulResult;
import hk.advanpro.cloud.api.result.oss.ProdectVersionResult;
import hk.advanpro.cloud.api.result.ddc.DeviceInfoResult;
import hk.advanpro.cloud.api.result.uc.GetMyProfileResult;
import hk.advanpro.cloud.api.result.uc.LoginResult;
import hk.advanpro.cloud.android.model.Token;

import static org.junit.Assert.assertTrue;

/**
 * cloudService
 * Created by jalin on 2017/11/17.
 */
public class CloudServiceTest {
    public static final String TAG = "CloudServiceTest";

    static String tokenValue = "";

    static Token token = new Token() {
        @Override
        public String getToken() {
            return tokenValue;
        }

        @Override
        public void setToken(String token) {
            System.out.print(TAG + "----token=" + token);
            tokenValue = token;
        }
    };
    static UserAgent userAgent = new UserAgent() {
        @Override
        public String getUserAgent() {
            return "Unifit/3.2.0 rev 70566 (motorolaXT1085) android/5.1 (TA004043UE)";
        }
    };

    //创建并且登录
    @BeforeClass
    public static void testCreateAndLogin() throws Exception {
        CloudService.initUserAgent(userAgent);
        CloudService.initCloudAddressType(CloudAddressType.DEV);
        CloudService cloudService = CloudService.createDefault(token);
        Assert.assertNotNull(cloudService);


        // 登录admin
//        RestfulResult<LoginResult> rs = CloudService.getDefault().getUcApi().login("15989781572",
//                "123456", "en").await();

        RestfulResult<LoginResult> rs = CloudService.getDefault().getAdminApi().login("zhouxiaolin",
                "zxlsuccess").await();
        Assert.assertTrue(rs.getResponse().isSuccessful());
        Assert.assertTrue(rs.getCode() == 200);
        Assert.assertNotNull(JSON.toJSONString(rs.getData(), true));
    }

    //获取登录用户基本信息请求接口
    @Test
    public void getMyProfile() throws Exception {
        RestfulResult<GetMyProfileResult> rs = CloudService.getDefault().getUcApi().getMyProfile().await();
        Assert.assertTrue(rs.getResponse().isSuccessful());
        Assert.assertTrue(rs.getCode() == 200);
        Assert.assertNotNull(JSON.toJSONString(rs.getData(), true));
    }

    @Test
    public void getVersion() throws Exception {
        RestfulResult<ProdectVersionResult> rs = CloudService.getDefault().getAdminApi().getVersion("APP", "ANDROID", "UNIFIT").await();
        Assert.assertTrue(rs.getResponse().isSuccessful());
        Assert.assertTrue(rs.getCode() == 200);
        Assert.assertNotNull(JSON.toJSONString(rs.getData(), true));
    }


    @Test
    public void testGetDeviceInfo() {
        RestfulResult<DeviceInfoResult> datas = null;
        try {
            datas = CloudService.getDefault().getDdcApi().getDeviceInfo("SIS01DP11700000399").await();
        } catch (Exception e) {
            e.printStackTrace();
        }
        assertTrue(datas.isSuccess());
    }
}
