package hk.advanpro.cloud.api.payload;

import com.alibaba.fastjson.annotation.JSONField;

/**
 * Created by jalin on 2018/2/9.
 */

public class QuickLoginPayload {

    public static final int TYPE_ACCOUNT = 0;
    public static final int TYPE_PHONE = 1;
    public static final int TYPE_EMAIL = 2;
    public static final int TYPE_WECHAT = 3;

    @JSONField(name = "account")
    private String account;
    @JSONField(name = "vcode")
    private String vcode;// 验证码
    @JSONField(name = "app_code")
    private String app_code;// 经过RSA的公钥加密字符串
    @JSONField(name = "lang")
    private String lang;
    /**
     * 账号类型
     * - 0:账号
     * - 1:手机
     * - 2:邮箱
     * - 3:微信
     */
    @JSONField(name = "account_type")
    private int accountType;
    @JSONField(name = "nick_name")
    private String nickName;
    @JSONField(name = "info")
    private String info;

    public static QuickLoginPayload creatQuickLoginByPhone(String phone, String vcode, String lang) {
        QuickLoginPayload payload = new QuickLoginPayload();
        payload.setLang(lang);
        payload.setAccountType(TYPE_PHONE);
        payload.setAccount(phone);
        payload.setVcode(vcode);
        return payload;
    }

    public static QuickLoginPayload creatQuickLoginByWechat(String account, String nickName, String lang) {
        QuickLoginPayload payload = new QuickLoginPayload();
        payload.setLang(lang);
        payload.setAccountType(TYPE_WECHAT);
        payload.setAccount(account);
        payload.setNickName(nickName);
        return payload;
    }


    public String getAccount() {
        return account;
    }

    public void setAccount(String account) {
        this.account = account;
    }

    public String getVcode() {
        return vcode;
    }

    public void setVcode(String vcode) {
        this.vcode = vcode;
    }

    public String getLang() {
        return lang;
    }

    public void setLang(String lang) {
        this.lang = lang;
    }

    public int getAccountType() {
        return accountType;
    }

    public void setAccountType(int accountType) {
        this.accountType = accountType;
    }

    public String getNickName() {
        return nickName;
    }

    public void setNickName(String nickName) {
        this.nickName = nickName;
    }

    public String getInfo() {
        return info;
    }

    public void setInfo(String info) {
        this.info = info;
    }

    public String getApp_code() {
        return app_code;
    }

    public void setApp_code(String app_code) {
        this.app_code = app_code;
    }
}
