package hk.advanpro.cloud.api.payload;
import com.alibaba.fastjson.annotation.JSONField;

/**
 * 用户注册信息请求内容主体。
 * Created by yejianfei on 2017/8/12.
 */
public class UserRegisterPayload {

    @JSONField(name = "account")
    private String account;// 手机号码、账号或微信的unionid
    @JSONField(name = "vcode")
    private String vcode;// 验证码;微信登录方式时无须填充此字段
    @JSONField(name = "passwd")
    private String passwd;// 密码;微信登录方式时无须填充此字段
    @JSONField(name = "account_type")
    private int accountType;// 账号类型,0:账号,1:手机,3:微信
    @JSONField(name = "invite_code")
    private String inviteCode;// 邀请码;此字段目前只对孕呼吸
    @JSONField(name = "app_code")
    private String appCode;// 经过RSA的公钥加密字符串;此字段目前只对孕呼吸、呼吸宝

    @JSONField(name = "nick_name")
    private String nick_name;//微信昵称;微信登录方式时提供此字段
    @JSONField(name = "photo")
    private String photo;// 微信头像;微信登录方式时提供此字段

    @JSONField(name = "info")
    private Object info;// 个人信息-附加信息


    public UserRegisterPayload buildRegisterByPhone(String phone, String vcode) {
        UserRegisterPayload payload = new UserRegisterPayload();
        payload.setAccountType(1);
        payload.setAccount(phone);
        payload.setVcode(vcode);
        return payload;
    }

    /**
     * 用户注册-孕呼吸
     * 孕呼吸
     *
     * @param phone
     * @param vcode
     * @param inviteCode
     * @param info       个人信息-附加信息
     * @return
     */
    public UserRegisterPayload buildRegisterByPhone(String phone, String vcode, String inviteCode, Object info) {
        UserRegisterPayload payload = new UserRegisterPayload();
        payload.setAccountType(1);
        payload.setAccount(phone);
        payload.setVcode(vcode);
        payload.setInviteCode(inviteCode);
        payload.setInfo(info);
        return payload;
    }

    public UserRegisterPayload buildRegisterByWeChat(String unionid) {
        UserRegisterPayload payload = new UserRegisterPayload();
        payload.setAccountType(3);
        payload.setAccount(unionid);
        return payload;
    }

    public String getAccount() {
        return account;
    }

    /**
     * 手机号码、账号或微信的unionid
     *
     * @param account
     */
    public void setAccount(String account) {
        this.account = account;
    }

    public String getVcode() {
        return vcode;
    }

    /**
     * 验证码;微信登录方式时无须填充此字段
     *
     * @param vcode
     */
    public void setVcode(String vcode) {
        this.vcode = vcode;
    }

    public String getPasswd() {
        return passwd;
    }

    /**
     * 密码;微信登录方式时无须填充此字段
     *
     * @param passwd
     */
    public void setPasswd(String passwd) {
        this.passwd = passwd;
    }

    public int getAccountType() {
        return accountType;
    }

    /**
     * 账号类型
     * - 0:账号
     * - 1:手机
     * - 3:微信
     *
     * @param accountType
     */
    public void setAccountType(int accountType) {
        this.accountType = accountType;
    }

    public String getInviteCode() {
        return inviteCode;
    }

    public void setInviteCode(String inviteCode) {
        this.inviteCode = inviteCode;
    }

    public String getAppCode() {
        return appCode;
    }

    public void setAppCode(String appCode) {
        this.appCode = appCode;
    }

    public String getNick_name() {
        return nick_name;
    }

    public void setNick_name(String nick_name) {
        this.nick_name = nick_name;
    }

    public String getPhoto() {
        return photo;
    }

    public void setPhoto(String photo) {
        this.photo = photo;
    }

    public Object getInfo() {
        return info;
    }

    public void setInfo(Object info) {
        this.info = info;
    }
}
