package hk.advanpro.cloud.api.payload.course;

import java.util.List;

import hk.advanpro.cloud.api.result.course.CourseTrainingResult;

/**
 * Created by david on 2018/8/20.
 */

public class CourseRecord {
    /**
     * batchNo:String:批次号，主键，MD5(userId_deviceId_createTime)
     * userId:String:用户ID
     * deviceId:String:设备ID
     * createTime:long long:创建时间，毫秒时间戳
     * formatVersion:int:数据结构版本号，从1开始，当数据结构更新时，此版本号+1
     * version:long:版本号
     * sync:int:同步标记，0未同步，1已同步
     * raws:string:关联原始数据url
     * info:object:数据信息
     */

    private String batch_no;
    private List<String> device_id;
    private String create_time;
    private String category;
    private String format;
    private String format_version;
    private String version;
    private int time_zone;
    private int sync;
    private String raws;
    private List<CourseTrainingResult.EarnedPrizes> prize;
    //数据信息
    private CourseInfo info;

    public int getTime_zone() { return time_zone; }

    public void setTime_zone(int time_zone) { this.time_zone = time_zone; }

    public List<CourseTrainingResult.EarnedPrizes> getPrize() {
        return prize;
    }

    public void setPrize(List<CourseTrainingResult.EarnedPrizes> prize) {
        this.prize = prize;
    }

    public String getBatch_no() {
        return batch_no;
    }

    public void setBatch_no(String batch_no) {
        this.batch_no = batch_no;
    }

    public List<String> getDevice_id() {
        return device_id;
    }

    public void setDevice_id(List<String> device_id) {
        this.device_id = device_id;
    }

    public String getCreate_time() {
        return create_time;
    }

    public void setCreate_time(String create_time) {
        this.create_time = create_time;
    }

    public String getFormat_version() {
        return format_version;
    }

    public void setFormat_version(String format_version) {
        this.format_version = format_version;
    }

    public String getCategory() {
        return category;
    }

    public void setCategory(String category) {
        this.category = category;
    }

    public String getFormat() {
        return format;
    }

    public void setFormat(String format) {
        this.format = format;
    }

    public String getVersion() {
        return version;
    }

    public void setVersion(String version) {
        this.version = version;
    }

    public int getSync() {
        return sync;
    }

    public void setSync(int sync) {
        this.sync = sync;
    }

    public String getRaws() {
        return raws;
    }

    public void setRaws(String raws) {
        this.raws = raws;
    }

    public CourseInfo getInfo() {
        return info;
    }

    public void setInfo(CourseInfo info) {
        this.info = info;
    }

    public static class CourseInfo {

        /**
         * type:int:0:课程训练，1:单项训练
         * course_id:string:课程ID（单项训练时为空）
         * chapter_id:string:章节ID（同上）
         * lesson_id:string:课时ID（同上）
         * training_id:string:单项训练ID（课程训练时为空）
         * name:string:训练名称
         * duration:int:训练时长，单位：秒
         * training_data:string:训练数据，json字符串，根据不同课程，格式不一样，由html完成训练后返回
         */
        private int type;
        private String course_id;
        private String chapter_id;
        private String lesson_id;
        private String training_id;
        private String name;
        private int duration;
        private TrainingData training_data;

        public int getType() {
            return type;
        }

        public void setType(int type) {
            this.type = type;
        }

        public String getCourse_id() {
            return course_id;
        }

        public void setCourse_id(String course_id) {
            this.course_id = course_id;
        }

        public String getChapter_id() {
            return chapter_id;
        }

        public void setChapter_id(String chapter_id) {
            this.chapter_id = chapter_id;
        }

        public String getLesson_id() {
            return lesson_id;
        }

        public void setLesson_id(String lesson_id) {
            this.lesson_id = lesson_id;
        }

        public String getTraining_id() {
            return training_id;
        }

        public void setTraining_id(String training_id) {
            this.training_id = training_id;
        }

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }

        public int getDuration() {
            return duration;
        }

        public void setDuration(int duration) {
            this.duration = duration;
        }

        public TrainingData getTraining_data() {
            return training_data;
        }

        public void setTraining_data(TrainingData training_data) {
            this.training_data = training_data;
        }
    }

    public static class TrainingData {

        private int score;//获得分数
        private long start_time;//实际训练开始时间（除去前奏）
        private long end_time;//实际训练结束时间（除去结尾）
        private int total_count;//总训练多少次
        private double max_time;//最大时间
        private double min_time;//最少时间
        private double avg_time;//平均时间
        private int max_index;//最长屏息的索引值编号
        private int min_index;//最短屏息的索引值编号
        private List<SuspendsData> suspends;//每次训练数据

        public int getScore() {
            return score;
        }

        public void setScore(int score) {
            this.score = score;
        }

        public long getStart_time() {
            return start_time;
        }

        public void setStart_time(long start_time) {
            this.start_time = start_time;
        }

        public long getEnd_time() {
            return end_time;
        }

        public void setEnd_time(long end_time) {
            this.end_time = end_time;
        }

        public int getTotal_count() {
            return total_count;
        }

        public void setTotal_count(int total_count) {
            this.total_count = total_count;
        }

        public double getMax_time() {
            return max_time;
        }

        public void setMax_time(double max_time) {
            this.max_time = max_time;
        }

        public double getMin_time() {
            return min_time;
        }

        public void setMin_time(double min_time) {
            this.min_time = min_time;
        }

        public double getAvg_time() {
            return avg_time;
        }

        public void setAvg_time(double avg_time) {
            this.avg_time = avg_time;
        }

        public int getMax_index() {
            return max_index;
        }

        public void setMax_index(int max_index) {
            this.max_index = max_index;
        }

        public int getMin_index() {
            return min_index;
        }

        public void setMin_index(int min_index) {
            this.min_index = min_index;
        }

        public List<SuspendsData> getSuspends() {
            return suspends;
        }

        public void setSuspends(List<SuspendsData> suspends) {
            this.suspends = suspends;
        }


    }

    public static class SuspendsData {
        private int no;//序号
        private String start_time;//训练开始时间
        private String end_time;//训练结束时间
        private double duration;//训练时长
        private long startDtIndex;//屏息起始数据点索引值
        private long endDtIndex;//屏息结束数据点索引值
        private double diving_depth;//潜水的深度

        public int getNo() {
            return no;
        }

        public void setNo(int no) {
            this.no = no;
        }

        public long getStartDtIndex() {
            return startDtIndex;
        }

        public void setStartDtIndex(long startDtIndex) {
            this.startDtIndex = startDtIndex;
        }

        public long getEndDtIndex() {
            return endDtIndex;
        }

        public void setEndDtIndex(long endDtIndex) {
            this.endDtIndex = endDtIndex;
        }

        public String getStart_time() {
            return start_time;
        }

        public void setStart_time(String start_time) {
            this.start_time = start_time;
        }

        public String getEnd_time() {
            return end_time;
        }

        public void setEnd_time(String end_time) {
            this.end_time = end_time;
        }

        public double getDuration() {
            return duration;
        }

        public void setDuration(double duration) {
            this.duration = duration;
        }

        public double getDiving_depth() {
            return diving_depth;
        }

        public void setDiving_depth(double diving_depth) {
            this.diving_depth = diving_depth;
        }
    }


}
