package hk.advanpro.cloud.api.payload.course;

import java.io.Serializable;

/**
 * 课程训练上传
 *
 * @author jalin
 * created at 2018/8/30
 */
public class CourseTrainUploadPayload implements Serializable {

    /**
     * 批次号
     */
    private String batch_no;
    private String device_id;
    /**
     * 开始时间 格林时间  如： 2018-08-27T06:31:50.457Z
     * DateUtils.formatDateToUTC(time)
     */
    private String create_time;

    /**
     * app时区
     */
    private int time_zone;
    /**
     * 分类
     */
    private String category;
    /**
     * 类别
     */
    private String format;
    private String format_version;
    private String version;
    private int sync;
    /**
     * 关联原始数据文档
     */
    private String raws;
    //数据信息
    private Info info;


    public static class Info implements Serializable {
        /**
         * 0:课程训练 1:单项训练
         */
        private int type;
        /**
         * 课程主键
         */
        private String course_id;
        /**
         * 章节主键
         */
        private String chapter_id;
        /**
         * 课时主键
         */
        private String lesson_id;
        /**
         * 单项训练主键
         */
        private String training_id;
        /**
         * 训练名称
         */
        private String name;
        /**
         * 训练时长
         */
        private int duration;
        /**
         * 训练数据,不同APP不同
         */
        private Object training_data;

        public int getType() {
            return type;
        }

        public void setType(int type) {
            this.type = type;
        }

        public String getCourse_id() {
            return course_id;
        }

        public void setCourse_id(String course_id) {
            this.course_id = course_id;
        }

        public String getChapter_id() {
            return chapter_id;
        }

        public void setChapter_id(String chapter_id) {
            this.chapter_id = chapter_id;
        }

        public String getLesson_id() {
            return lesson_id;
        }

        public void setLesson_id(String lesson_id) {
            this.lesson_id = lesson_id;
        }

        public String getTraining_id() {
            return training_id;
        }

        public void setTraining_id(String training_id) {
            this.training_id = training_id;
        }

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }

        public int getDuration() {
            return duration;
        }

        public void setDuration(int duration) {
            this.duration = duration;
        }

        public Object getTraining_data() {
            return training_data;
        }

        public void setTraining_data(Object training_data) {
            this.training_data = training_data;
        }
    }

    public String getBatch_no() {
        return batch_no;
    }

    public void setBatch_no(String batch_no) {
        this.batch_no = batch_no;
    }

    public String getDevice_id() {
        return device_id;
    }

    public void setDevice_id(String device_id) {
        this.device_id = device_id;
    }

    public String getCreate_time() {
        return create_time;
    }

    public void setCreate_time(String create_time) {
        this.create_time = create_time;
    }

    public String getCategory() {
        return category;
    }

    public void setCategory(String category) {
        this.category = category;
    }

    public String getFormat() {
        return format;
    }

    public void setFormat(String format) {
        this.format = format;
    }

    public String getFormat_version() {
        return format_version;
    }

    public void setFormat_version(String format_version) {
        this.format_version = format_version;
    }

    public String getVersion() {
        return version;
    }

    public void setVersion(String version) {
        this.version = version;
    }

    public int getSync() {
        return sync;
    }

    public void setSync(int sync) {
        this.sync = sync;
    }

    public String getRaws() {
        return raws;
    }

    public void setRaws(String raws) {
        this.raws = raws;
    }


    public Info getInfo() {
        return info;
    }

    public void setInfo(Info info) {
        this.info = info;
    }

    public int getTime_zone() {
        return time_zone;
    }

    public void setTime_zone(int time_zone) {
        this.time_zone = time_zone;
    }
}
