package hk.advanpro.cloud.api.payload.oc;

import com.alibaba.fastjson.annotation.JSONField;

import java.util.List;

/**
 * 订单请求
 */
public class OrderSubmitPayload {

    /**
     * 收货人
     */
    @JSONField(name = "receive_name")
    private String receiveName;

    /**
     * 收货手机
     */
    @JSONField(name = "receive_phone")
    private String receivePhone;
    /**
     * 收货人省份
     */
    @JSONField(name = "receive_province")
    private String receiveProvince;
    /**
     * 收货人城市
     */
    @JSONField(name = "receive_city")
    private String receiveCity;
    /**
     * 收货人区/县
     */
    @JSONField(name = "receive_county")
    private String receiveCounty;
    /**
     * 收货人具体地址
     */
    @JSONField(name = "receive_address")
    private String receiveAddress;
    /**
     * 发票信息（非必填）
     */
    @JSONField(name = "invoice")
    private Invoice invoice;
    /**
     * 订单商品详情
     */
    @JSONField(name = "product_skus")
    private List<ProductSku> productSkus;

    public static class ProductSku {
        /**
         * 商品主键
         */
        private String id;
        /**
         * 商品数量
         */
        private int quantity;
        /**
         * 规格
         */
        @JSONField(name = "tag_content")
        private String tagContent;

        public String getId() {
            return id;
        }

        public void setId(String id) {
            this.id = id;
        }

        public int getQuantity() {
            return quantity;
        }

        public void setQuantity(int quantity) {
            this.quantity = quantity;
        }

        public String getTagContent() {
            return tagContent;
        }

        public void setTagContent(String tagContent) {
            this.tagContent = tagContent;
        }
    }

    /**
     * 发票信息
     */
    public static class Invoice {
        /**
         * 发票抬头（公司或个人名称）
         */
        private String title;
        /**
         * 公司税号(个人非必填)
         */
        private String tax;
        /**
         * 类型
         * -0：公司
         * -1：个人
         */
        private int type;

        public String getTitle() {
            return title;
        }

        public void setTitle(String title) {
            this.title = title;
        }

        public String getTax() {
            return tax;
        }

        public void setTax(String tax) {
            this.tax = tax;
        }

        public int getType() {
            return type;
        }

        public void setType(int type) {
            this.type = type;
        }
    }

    public String getReceiveName() {
        return receiveName;
    }

    public void setReceiveName(String receiveName) {
        this.receiveName = receiveName;
    }

    public String getReceivePhone() {
        return receivePhone;
    }

    public void setReceivePhone(String receivePhone) {
        this.receivePhone = receivePhone;
    }

    public String getReceiveProvince() {
        return receiveProvince;
    }

    public void setReceiveProvince(String receiveProvince) {
        this.receiveProvince = receiveProvince;
    }

    public String getReceiveCity() {
        return receiveCity;
    }

    public void setReceiveCity(String receiveCity) {
        this.receiveCity = receiveCity;
    }

    public String getReceiveCounty() {
        return receiveCounty;
    }

    public void setReceiveCounty(String receiveCounty) {
        this.receiveCounty = receiveCounty;
    }

    public String getReceiveAddress() {
        return receiveAddress;
    }

    public void setReceiveAddress(String receiveAddress) {
        this.receiveAddress = receiveAddress;
    }

    public Invoice getInvoice() {
        return invoice;
    }

    public void setInvoice(Invoice invoice) {
        this.invoice = invoice;
    }

    public List<ProductSku> getProductSkus() {
        return productSkus;
    }

    public void setProductSkus(List<ProductSku> productSkus) {
        this.productSkus = productSkus;
    }
}
