package hk.advanpro.cloud.api.payload.soc;

import com.alibaba.fastjson.annotation.JSONField;

import java.util.Arrays;
import java.util.List;

/**
 * 进入/退出频道
 * Created by jason on 2018/7/3
 */
public class ChannelsActionPayload {
    /**
     * 操作信息
     * - 15:加入
     * - 16:退出
     */
    @JSONField(name = "action")
    private int action;

    /**
     * 进入或者退出频道主键
     */
    @JSONField(name = "channels")
    private List<String> channels;

    public ChannelsActionPayload() {
    }

    public ChannelsActionPayload(int action, String... channels) {
        this.action = action;
        this.channels = Arrays.asList(channels);
    }


    public ChannelsActionPayload(int action, List<String> channels) {
        this.action = action;
        this.channels = channels;
    }

    public int getAction() {
        return action;
    }

    public void setAction(int action) {
        this.action = action;
    }

    public List<String> getChannels() {
        return channels;
    }

    public void setChannels(List<String> channels) {
        this.channels = channels;
    }
}
