package hk.advanpro.cloud.api.payload.soc;

import com.alibaba.fastjson.annotation.JSONField;
import com.google.gson.JsonObject;

import java.util.List;

/**
 * 频道信息
 * Created by jason on 2018/7/3
 */
public class ChannelsPayload {
    private String id;

    private String icon;

    @JSONField(name = "app_code")
    private String appCode;

    private String name;

    private String code;

    private String desc;

    private int order;

    /**
     * 频道类型
     * - 0:系统频道
     * - 1:自定义频道
     */
    private int type;

    @JSONField(name = "purviews")
    private List<Purviews> purviews;

    /**
     * 状态
     * - 0:禁用
     * - 1:启用
     */
    private int status;

    private JsonObject extras;

    public List<Purviews> getPurviews() {
        return purviews;
    }

    public void setPurviews(List<Purviews> purviews) {
        this.purviews = purviews;
    }

    public String getIcon() {
        return icon;
    }

    public void setIcon(String icon) {
        this.icon = icon;
    }

    public String getAppCode() {
        return appCode;
    }

    public void setAppCode(String appCode) {
        this.appCode = appCode;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getDesc() {
        return desc;
    }

    public void setDesc(String desc) {
        this.desc = desc;
    }

    public int getOrder() {
        return order;
    }

    public void setOrder(int order) {
        this.order = order;
    }

    public int getType() {
        return type;
    }

    public void setType(int type) {
        this.type = type;
    }


    public int getStatus() {
        return status;
    }

    public void setStatus(int status) {
        this.status = status;
    }

    public JsonObject getExtras() {
        return extras;
    }

    public void setExtras(JsonObject extras) {
        this.extras = extras;
    }

    private static class Purviews {
        /**
         * 角色
         */
        @JSONField(name = "role")
        private Role role;

        /**
         * 权限集合(1:具有该权限 0:不具有,全部则都为1, 权限依次是可加入/可发帖/可读帖/可评论/可关注/可点赞/可举报/可收藏/可分享)
         */
        @JSONField(name = "purview")
        private List<Integer> purview;

        private static class Role {
            private String id;
            private String name;

            public String getId() {
                return id;
            }

            public void setId(String id) {
                this.id = id;
            }

            public String getName() {
                return name;
            }

            public void setName(String name) {
                this.name = name;
            }
        }

        public Role getRole() {
            return role;
        }

        public void setRole(Role role) {
            this.role = role;
        }

        public List<Integer> getPurview() {
            return purview;
        }

        public void setPurview(List<Integer> purview) {
            this.purview = purview;
        }
    }
}
