package hk.advanpro.cloud.api.payload.soc;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.annotation.JSONField;

import java.util.List;

/**
 * 社交用户初始化
 * Created by jason on 2018/7/3
 */
public class PeopleInitPayload {
    /**
     * 社交角色编码
     */
    @JSONField(name = "roles")
    private List<String> roles;

    /**
     * 推荐人
     */
    @JSONField(name = "from_user")
    private String fromUser;

    /**
     * 已加入频道
     */
    @JSONField(name = "channels")
    private List<String> channels;

    /**
     * 已关注人员社交主键
     */
    @JSONField(name = "followings")
    private List<String> followings;

    /**
     * 附加信息
     */
    @JSONField(name = "extras")
    private JSONObject extras;

    /**
     * 是否创建群聊(为true时，name、icon、type为必需参数)
     */
    @JSONField(name = "create_group")
    private boolean createGroup;

    /**
     * 群名称
     */
    private String name;
    /**
     * 群图标
     */
    private String icon;
    /**
     * qun性质
     * - 0:普通群
     * - 1:亲密群
     */
    private int type;

    public List<String> getRoles() {
        return roles;
    }

    public void setRoles(List<String> roles) {
        this.roles = roles;
    }

    public String getFromUser() {
        return fromUser;
    }

    public void setFromUser(String fromUser) {
        this.fromUser = fromUser;
    }

    public List<String> getChannels() {
        return channels;
    }

    public void setChannels(List<String> channels) {
        this.channels = channels;
    }

    public List<String> getFollowings() {
        return followings;
    }

    public void setFollowings(List<String> followings) {
        this.followings = followings;
    }

    public JSONObject getExtras() {
        return extras;
    }

    public void setExtras(JSONObject extras) {
        this.extras = extras;
    }

    public boolean getCreateGroup() {
        return createGroup;
    }

    public void setCreateGroup(boolean createGroup) {
        this.createGroup = createGroup;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getIcon() {
        return icon;
    }

    public void setIcon(String icon) {
        this.icon = icon;
    }

    public int getType() {
        return type;
    }

    public void setType(int type) {
        this.type = type;
    }

}
