package hk.advanpro.cloud.api.payload.soc;

import com.alibaba.fastjson.annotation.JSONField;

import java.util.Arrays;
import java.util.List;

/**
 * 关注/取消关注/举报/拉黑他人
 * Created by jason on 2018/7/3
 */
public class PeoplePayload {
    /**
     * 操作类型
     * - 1:关注
     * - 2:取消关注
     * - 5:拉黑
     * - 6:取消拉黑
     * - 7:举报
     * - 8:取消举报
     */
    @JSONField(name = "action")
    private int action;

    /**
     * 关注或者取消关注他人主键
     */
    @JSONField(name = "users")
    private List<String> users;

    public PeoplePayload(int action, String... users) {
        this.action = action;
        this.users = Arrays.asList(users);

    }

    public PeoplePayload(int action, List<String> users) {
        this.action = action;
        this.users = users;
    }

    public int getAction() {
        return action;
    }

    public void setAction(int action) {
        this.action = action;
    }

    public List<String> getUsers() {
        return users;
    }

    public void setUsers(List<String> users) {
        this.users = users;
    }
}
