package hk.advanpro.cloud.api.payload.soc;

import com.alibaba.fastjson.annotation.JSONField;
import com.google.gson.JsonObject;

/**
 * 点赞/收藏/举报帖子
 * Created by jason on 2018/7/3
 */
public class PostsPayload {
    /**
     * 操作信息
     * - 3:点赞
     * - 4:取消赞
     * - 7:举报
     * - 8:取消举报
     * - 11:收藏
     * - 12:取消收藏
     * - 17:踩
     * - 18:取消踩
     * - 19:分享
     */
    @JSONField(name = "action")
    private int action;

    /**
     * 附加信息
     */
    @JSONField(name = "extras")
    private JsonObject extras;

    @JSONField(name = "id")
    private String id;

    public PostsPayload() {
    }

    public PostsPayload(int action, String id) {
        this.action = action;
        this.id = id;
    }

    public PostsPayload(String id, int action, JsonObject extras) {
        this.action = action;
        this.extras = extras;
        this.id = id;
    }


    public int getAction() {
        return action;
    }

    public void setAction(int action) {
        this.action = action;
    }

    public JsonObject getExtras() {
        return extras;
    }

    public void setExtras(JsonObject extras) {
        this.extras = extras;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }
}
