package hk.advanpro.cloud.api.payload.soc;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.annotation.JSONField;
import com.google.gson.JsonObject;

import java.util.List;
import java.util.Map;

/**
 * 发帖/转发/评论
 * Created by jason on 2018/7/3
 */
public class SendPostOrCommentsPayload {
    /**
     * 被转发或者被评论帖子主键
     */
    @JSONField(name = "post_id")
    private String post_id;

    /**
     * 父评论主键
     */
    @JSONField(name = "parent_id")
    private String parent_id;

    /**
     * 父评论作者主键
     */
    @JSONField(name = "parent_author")
    private String parent_author;

    /**
     * 帖子图标
     */
    @JSONField(name = "icon")
    private String icon;

    /**
     * 帖子标题
     */
    @JSONField(name = "title")
    private String title;

    /**
     * 帖子正文
     */
    @JSONField(name = "text")
    private String text;

    /**
     * 图片
     */
    @JSONField(name = "pictures")
    private List<String> pictures;

    /**
     * 视频
     */
    @JSONField(name = "videos")
    private List<String> videos;

    /**
     * 是否匿名
     */
    @JSONField(name = "anonymous")
    private Boolean anonymous;

    /**
     * 标签
     */
    @JSONField(name = "symbols")
    private JSONObject symbols;

    /**
     * 吉祥物
     */
    @JSONField(name = "mascot")
    private String mascot;

    /**
     * 帖子分类  - 0:文字 - 1:晒图 - 2:提问 - 3:训练
     */
    @JSONField(name = "category")
    private int category;

    /**
     * 帖子类型  - 0:原创  - 1:评论  - 2:转发
     */
    @JSONField(name = "type")
    private int type;

    /**
     * 发布频道
     */
    @JSONField(name = "channels")
    private List<String> channels;

    /**
     * 吉祥物留言
     */
    @JSONField(name = "message")
    private List<String> message;

    /**
     * 附加信息
     */
    @JSONField(name = "extras")
    private JSONObject extras;

    public String getPost_id() {
        return post_id;
    }

    public void setPost_id(String post_id) {
        this.post_id = post_id;
    }

    public String getParent_id() {
        return parent_id;
    }

    public void setParent_id(String parent_id) {
        this.parent_id = parent_id;
    }

    public String getParent_author() {
        return parent_author;
    }

    public void setParent_author(String parent_author) {
        this.parent_author = parent_author;
    }

    public String getIcon() {
        return icon;
    }

    public void setIcon(String icon) {
        this.icon = icon;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getText() {
        return text;
    }

    public void setText(String text) {
        this.text = text;
    }

    public List<String> getPictures() {
        return pictures;
    }

    public void setPictures(List<String> pictures) {
        this.pictures = pictures;
    }

    public List<String> getVideos() {
        return videos;
    }

    public void setVideos(List<String> videos) {
        this.videos = videos;
    }

    public Boolean getAnonymous() {
        return anonymous;
    }

    public void setAnonymous(Boolean anonymous) {
        this.anonymous = anonymous;
    }

    public JSONObject getSymbols() {
        return symbols;
    }

    public void setSymbols(JSONObject symbols) {
        this.symbols = symbols;
    }

    public String getMascot() {
        return mascot;
    }

    public void setMascot(String mascot) {
        this.mascot = mascot;
    }


    public int getCategory() {
        return category;
    }

    public void setCategory(int category) {
        this.category = category;
    }

    public int getType() {
        return type;
    }

    public void setType(int type) {
        this.type = type;
    }

    public List<String> getChannels() {
        return channels;
    }

    public void setChannels(List<String> channels) {
        this.channels = channels;
    }

    public List<String> getMessage() {
        return message;
    }

    public void setMessage(List<String> message) {
        this.message = message;
    }

    public JSONObject getExtras() {
        return extras;
    }

    public void putExtraValue(String key, Object value) {
        if (getExtras() == null) {
            extras = new JSONObject();
        }
        extras.put(key, value);
    }

    public void setExtras(JSONObject extras) {
        this.extras = extras;
    }
}
